/**
 * Created by zhujunchao on 16/5/8.
 */
angular.module('starter.home', ['ionic',
    'ngCordova',
    'ngResource',
    'home.services',
    'starter.services',
  ])
  .controller('HomeCtrl', function ($scope,
    $rootScope,
    $ionicPopup,
    $location,
    Chats,
    ionicDatePicker,
    $ionicTabsDelegate,
    $ionicPopover,
    $ionicHistory,
    $state,
    $window,
    $cordovaInAppBrowser,
    $stateParams,
    // getHotWordsService,
    getAnnuCategoryService, getAnnuProductCodesService, Toolkit,
    SearchSuggestService,
    $cordovaFileOpener2) {



    $scope.boardName='',
    $scope.form = {
      keyword: ""
    }

    var version = "4.2";
    // if (version != JSON.parse(window.localStorage.getItem("version-tip"))) {
    //   window.localStorage.setItem("version-tip", JSON.stringify(version));

    //   Toolkit.alert('当前版本 v4.2;</br>' +
    //     '1.完善下拉列表不选中直接查询时的行为;</br>' +
    //     '2.解决基金净值显示时多出的括号问题;</br>' +
    //     '3.excel文件图标显示错误问题;</br>' +
    //     '4.拼音和简称检索问题;</br>');
    // }

    $scope.getLogo = 'img/hd-logo.png';
    $scope.loadCategoryDic = function () {
      if (Global.CategoryDic) return;
      Global.CategoryDic = JSON.parse(window.localStorage.getItem("annu-category"));
      var promise = getAnnuCategoryService.query().$promise;

      promise.then(function (_response) {
        if (_response.status == "1") {
          Global.CategoryDic = _response.codes;
          window.localStorage.setItem("annu-category", JSON.stringify(Global.CategoryDic));
        } else {}
      }, function () {});
    }();

    $scope.loadProductCodes = function () {
      if (Global.ProductCodes) return;
      Global.ProductCodes = JSON.parse(window.localStorage.getItem("product-codes"));
      if (Global.ProductCodes && Global.ProductCodes.stocks) {
        $scope.codeList = Global.ProductCodes.stocks.concat(Global.ProductCodes.funds, Global.ProductCodes.bonds);
      }
      var promise = getAnnuProductCodesService.query().$promise;

      promise.then(function (_response) {
        if (_response.status == "1") {
          Global.ProductCodes = _response.codes;
          window.localStorage.setItem("product-codes", JSON.stringify(Global.ProductCodes));
          $scope.codeList = Global.ProductCodes.stocks.concat(Global.ProductCodes.funds, Global.ProductCodes.bonds);

        } else {}
      }, function () {});
    }();



    // $scope.loadHotWords = function () {
    //   if ($scope.hotWords) return;
    //   $scope.hotWords = JSON.parse(window.localStorage.getItem("hot-words"));
    //   var promise = getHotWordsService.query().$promise;
    //
    //   promise.then(function (_response) {
    //     if (_response.status == "1") {
    //       $scope.hotWords = _respons e.hotwords;
    //       window.localStorage.setItem("hot-words", JSON.stringify($scope.hotWords));
    //     } else {}
    //   }, function () {
    //     $scope.hotWords = [{
    //       wordName: '收购'
    //     }, {
    //       wordName: '增持'
    //     }, {
    //       wordName: '重组'
    //     }, {
    //       wordName: '创业板'
    //     }, {
    //       wordName: '私有化'
    //     }];
    //   });
    // }();


    $scope.loadUser = function () {
      if (Global.User) return;

      Global.User = JSON.parse(window.localStorage.getItem("user"));
    }();

    $scope.goLogin = function () {
      if (Global.User) {
        $location.path('/tab/me');
      } else {
        $location.path('/tab/login');
      }
    }

    $scope.goNews = function () {
      if (Global.User) {
        $location.path('/tab/news');
      } else {
        $location.path('/tab/login');
      }
    }

    $scope.goMe = function () {
      $location.path('/tab/me');
    }

    $scope.goSearch = function (searchName) {
      // if($scope.showCodeList && $scope.filterCodeList[0]=="undefined")
      // {
      //  $scope.setQueryCode($scope.filterCodeList[0]);
      //  $scope.showCodeList=false;
      //  return;
      // }
      if (searchName == undefined) {
        Toolkit.alert("请输入需要搜索的内容");
        return;
      }
      $scope.showCodeList = false;
      if (searchName) {
        window.localStorage.setItem('tab.home.searchName', searchName)
        $location.path('/tab/searchResult/' + searchName);
      }
    }


    $scope.goHome = function () {

      //暂时的解决问题方案
      $window.history.back();
      $window.history.back();

    }

    $scope.openBrowser = function (url) {
      document.addEventListener('deviceready', function () {

        var options = {
          location: "no"
        };

        $cordovaInAppBrowser.open(url, '_blank', options).then(function () {
          console.log("InAppBrowser opened success");
        }, function (error) {
          console.log("Error: " + error);
        });

      }, false);
    };

    /*
            document.addEventListener('deviceready', function () {

                $rootScope.$on("$cordovaInAppBrowser:exit", function (event, result) {
                    alert("Exited Browser");
                    console.log(JSON.stringify(result));
                });


                $rootScope.$on("$cordovaInAppBrowser:loadstop", function (event, result) {
                    alert("Load Stop event");
                    console.log(JSON.stringify(result));
                })
            }, false)
    */

    $scope.openDatePicker = function () {
      ionicDatePicker.openDatePicker(ipObj1);
    };

    $scope.goForward = function () {
      var selected = $ionicTabsDelegate.selectedIndex();
      if (selected != -1) {
        $ionicTabsDelegate.select(selected + 1);
      }
    }

    $scope.goBack = function () {
      var selected = $ionicTabsDelegate.selectedIndex();
      if (selected != -1 && selected != 0) {
        $ionicTabsDelegate.select(selected - 1);
      }
    }


    $scope.onChange = function (keyword) {
      if (keyword.getByteSize() > 2 && keyword.length > 1) {
        $scope.showCodeList = true;
        SearchSuggestService.query({
          keyword: keyword
        }).$promise.then(function (_response) {
          if (_response.status == 0) {
            $scope.filterCodeList = [];
            _response.data.forEach(function (v) {
              v.toString = function () {
                return (v.code ? v.code : "") + ' ' + (v.typeLabel ? v.typeLabel : "") + ' ' + (v.name ? v.name : "");
              }
              $scope.filterCodeList.push(v);
            });
          }
        });
      } else {
        $scope.showCodeList = false;
      }
    };

    $scope.jumpTo = function (path) {
      $rootScope.jumpFromHome = true;
      $location.path(path);
    };







    $scope.setQueryCode = function (item) {
      var detailCode = item.code ? item.code : item.prodId;
      $scope.showCodeList = false;

      if (item.channelPath.indexOf("2010") == 0) {
        $location.path('/stockDetail/' + detailCode + "/getAnnuStockList/getProdStockDetail/");
      } else if (item.channelPath.indexOf("2011") == 0) {
        $location.path('/stockDetail/' + detailCode + "/getAnnuSharetransferList/getProdSharetransferDetail/");
      } else if (item.channelPath.indexOf("2012") == 0) {
        if (item.channelPath != "201212" && item.channelPath != "201213") {
          $location.path('/stockDetail/' + detailCode + "/getAnnuFundList/getProdFundDetail/" + item.channelPath);
        }
      } else if (item.channelPath.indexOf("2013") == 0) {
        $location.path('/stockDetail/' + detailCode + "/getAnnuFundMutualList/getProdFundMutualDetail/");
      } else if (item.channelPath.indexOf("2014") == 0) {
        $location.path('/stockDetail/' + detailCode + "/getAnnuBondList/getProdBondDetail/" + item.channelPath);
      } else if (item.channelPath.indexOf("2015") == 0) {
        $location.path('/stockDetail/' + detailCode + "/getAnnuAbsList/getProdAbsDetail/");
      } else if (item.channelPath.indexOf("2016") == 0) {
        if (item.channelPath != '201612') {
          $location.path('/stockDetail/' + detailCode + "//getProdPrivatefundDetail/" + item.channelPath);
        }
      } else if (item.channelPath.indexOf("2018") == 0) {
        $location.path('/stockDetail/' + detailCode + "//getRegularFirmDetail/" + item.channelPath);
      }

      $scope.form.keyword = item.code ? item.code : item.name;
    }
  })
