/**
 * Created by zhujunchao on 16/5/8.
 */
angular.module('starter.markets', ['ionic',
    'ngCordova',
    'ngResource',
    'public.services',
    "integralui",
    'starter.services'
  ])
  .controller('MarketsCtrl', function ($scope,
    $rootScope,
    $ionicTabsDelegate,
    $location,
    $ionicPopup,
    $stateParams,
    $ionicPopover,
    $sce,
    $http,
    $ionicLoading,
    $ionicHistory,
    ionicDatePicker,
    getAnnuService,
    getDetailService,
    getAnnuCategoryService,
    Toolkit,
    SearchSuggestService
  ) {


    $scope.queryCondition = {
      keyword: "",
    };

    $scope.keyword = "";
    $scope.boardCode = "";
    $scope.categoryMId = "";
    $scope.categorySId = "";
    $scope.startDate = "";
    $scope.endDate = "";
    $scope.pageNo = 1;
    $scope.pageSize = 20;

    $scope.methodList = null;
    $scope.annuArray = null;


    $scope.methodDetail = null;
    $scope.detailData = null;

    $scope.categoryCode = "";
    $scope.category = null;
    $scope.categoryName = "全部";

    $scope.board = null;
    $scope.boardName = "板块";

    $scope.listInfo = "正在加载...";
    //{{日期处理

    $scope.timeType = 'start';

    $scope.isClickDate = false;

    $scope.showCodeList = false;

    var ipObj = {
      callback: function (val) { //Mandatory
        var var1 = val ? new Date(val).Format("yyyy-MM-dd") : '';
        if ($scope.timeType == 'start') {
          $scope.startDate = var1;
        } else if ($scope.timeType == 'end') {
          $scope.endDate = var1;
        }
        $scope.doRefresh();
      },

      titleLabel: null, //Optional
      todayLabel: '今天', //Optional
      closeLabel: '清除', //Optional
      setLabel: '确定', //Optional
      from: new Date(1949, 10, 1), //Optional
      to: new Date(), //Optional
      inputDate: new Date(), //Optional
      mondayFirst: true, //Optional
      closeOnSelect: true, //Optional
      dateFormat: 'yyyy-MM-dd', //Optional
      templateType: 'popup', //Optional
      modalHeaderColor: 'bar-positive',
      closeOnSelect: false, //Optional
      modalFooterColor: 'bar-positive' //Optional
    };

    $scope.openDatePicker = function (type) {
      console.log(type);
      $scope.timeType = type;

      if ($scope.timeType == 'start') {
        ipObj.inputDate = $scope.startDate ? new Date($scope.startDate) : new Date();
        ipObj.from = new Date(1949, 10, 1);
        ipObj.to = $scope.endDate ? new Date($scope.endDate) : new Date();
      } else {
        ipObj.inputDate = $scope.endDate ? new Date($scope.endDate) : new Date();
        ipObj.from = $scope.startDate ? new Date($scope.startDate) : new Date(1949, 10, 1);
        ipObj.to = new Date();
      }

      ionicDatePicker.openDatePicker(ipObj);
    };

    //}} 日期处理


    $scope.myChart = null;
    $scope.myChart2 = null;

    $scope.showEcharts = function () {
      if ($scope.detailData.indexList == null) {
        return;
      }
      $scope.detailData.indexList.date.reverse();
      $scope.detailData.indexList.value.reverse();
      $scope.detailData.indexList.amount.reverse();

      // 基于准备好的dom，初始化echarts实例
      if (!$scope.myChart) {
        $scope.myChart = echarts.init(document.getElementById('kchart1'));
      }
      var option = {
        title: {
          text: ''
        },

        dataZoom: {
          y: '100%',
          show: true,
          realtime: true,
          start: 50,
          end: 100
        },
        grid: {
          left: 0,
          right: 0,
          bottom: 0
        },
        xAxis: [{
          type: 'category',
          boundaryGap: true,
          axisTick: {
            onGap: false
          },
          splitLine: {
            show: false
          },
          data: $scope.detailData.indexList.date
        }],
        yAxis: [{
          type: 'value',
          scale: true,
          boundaryGap: [0.05, 0.05],
          splitArea: {
            show: false
          }
        }],
        series: [{
          name: '上证指数',
          type: 'k',
          data: $scope.detailData.indexList.value
        }]
      };

      // 使用刚指定的配置项和数据显示图表。
      $scope.myChart.setOption(option);

      var option2 = {

        dataZoom: {
          show: true,
          realtime: true,
          start: 50,
          end: 100
        },
        grid: {

          left: 0,
          right: 0,
          bottom: 0
        },
        xAxis: [{
          type: 'category',
          position: 'top',
          boundaryGap: true,
          axisLabel: {
            show: false
          },
          axisTick: {
            onGap: false
          },
          splitLine: {
            show: false
          },
          data: $scope.detailData.indexList.date
        }],
        yAxis: [{
          type: 'value',
          scale: true,
          splitNumber: 3,
          boundaryGap: [0.05, 0.05],
          axisLabel: {
            formatter: function (v) {
              return Math.round(v / 100000000) + ' 亿'
            }
          },
          splitArea: {
            show: false
          }
        }],
        series: [{
          name: '成交金额(亿)',
          type: 'bar',
          symbol: 'none',
          data: $scope.detailData.indexList.amount
        }]
      };

      if ($scope.detailData.indexList.amount[$scope.detailData.indexList.amount.length - 1]) {
        if (!$scope.myChart2) {
          $scope.myChart2 = echarts.init(document.getElementById('kchart2'));
        }
        $scope.myChart2.setOption(option2);
        $scope.myChart.connect([$scope.myChart2]);
        $scope.myChart2.connect([$scope.myChart]);
      }

    }

    $scope.trustHtml = function (data) {
      return $sce.trustAsHtml(data);
    }

    $scope.setQueryCode = function (code) {
      if (code) {
        var index = code.indexOf(" ");
        $scope.queryCondition.keyword = code.substring(0, index);
      }
      $scope.closePopover();
      $scope.showCodeList = false;
    }

    $scope.search = function () {
      if ($scope.showCodeList) {
        $scope.setQueryCode($scope.filterCodeList[0]);
      }
      $scope.showCodeList = false;
      $scope.doRefresh();
    }
    $scope.goBack = function () {
      $ionicHistory.goBack();
    }

    //视图进入后的事件，设置对应的分类对象代码和板块对象代码
    //step 2：进入列表页时的事件处理，记录各个参数信息，根据分类元数据代码获取分类字典
    $scope.$on("$ionicView.enter", function (event, data) {
      // handle event
      // console.log("State Params: ", data);

      switch (data.stateName) {
        case 'tab.marketIndexList':
          {
            if (data.direction != "forward") {
              return;
            }

            //清空接口方法
            $scope.methodList = null;
            $scope.methodDetail = null;
            $scope.category = Toolkit.getCategory(data.stateParams.category);
            $scope.categoryMId = data.stateParams.categoryMid;
            $scope.categoryName = $scope.getCategoryMName();
            $scope.board = Toolkit.getCategory(data.stateParams.board);
            $scope.methodList = data.stateParams.method;
            $scope.viewTitle = data.stateParams.title;
            $scope.baseChannelPath = data.stateParams.categoryMid;

            if ($scope.categoryMId == '301112') { //基金净值
              $scope.extra = Toolkit.getCategory(21);

              //不同产品的选择条件名称不同
              $scope.extraName = '全部';
              $scope.extraMetaCode = '';

            }
            break;
          }

        case 'marketIndexDetail':
          {
            //清空接口方法
            $scope.methodList = null;
            $scope.methodDetail = null;
            $scope.methodList = data.stateParams.methodList;
            $scope.categoryMId = data.stateParams.categoryMid;
            $scope.methodDetail = data.stateParams.methodDetail;
            $scope.detailCode = data.stateParams.code;
            $scope.queryCondition.keyword = data.stateParams.code;
            $scope.viewTitle = data.stateParams.title;
            break;
          }

      }

      if ($scope.methodList) {
        //初始状态时，阻止下拉刷新
        $scope.hasMoreData = false;
      }

      //向服务器请求刷新数据
      $scope.doRefresh();
    });

    $scope.getKeywordPlaceholder = function () {
      switch ($scope.categorySId.toString()) {
        case '30121111':
          return '代码/简称/拼音缩写';
        case '30121112':
          return '代码/名称';
        case '30121113':
          return 'A股代码/简称/拼音缩写';
      }
      switch ($scope.categoryMId.toString()) {
        case '301211':
          return '代码/简称/拼音缩写';
        default:
          return $scope.isSupportCode() ? '代码/关键字' : '关键字';
      }
    }

    $scope.getCategoryMName = function () {
      if (!$scope.category)
        return null;

      for (var i = 0; i < $scope.category.length; i++) {
        if ($scope.categoryMId == $scope.category[i].key) {
          return $scope.category[i].value;
        }
      }
      return "全部";
    }

    //{{跳转到不同列表

    //产品列表
    // step 1：跳转去市场列表页，带着获取列表方法，分类元数据代码，中类代码，标题
    $scope.goMarketList = function (name, categoryMid) {
      switch (name) {
        case 'index':
          {
            $location.path('/tab/marketIndexList/getMarketIndexList/9593/00/指数行情/' + categoryMid);
            break;
          }
        case 'gegu':
          {
            $location.path('/tab/marketIndexList/getMarketIndividualList/9594/00/个股行情/' + categoryMid);
            break;
          }
        case 'statistic':
          {
            $location.path('/tab/marketIndexList/getMarketStatsList/9595/25/统计数据/' + categoryMid);
            break;
          }
        case 'hk':
          {
            $location.path('/tab/marketIndexList/getMarketHKList/9596/00/沪港通/' + categoryMid);
            break;
          }
        case 'zgg':
          {
            $location.path('/tab/marketIndexList/getMarketChinaList/9598/00/中概股/' + categoryMid);
            break;
          }
        default:
          {}
      }
    }

    $scope.toDecimal2 = function (m) {
      return Toolkit.toDecimal2(m);
    }

    $scope.getNeeqValue = function (project, value) {
      if (project == "总股本（亿股）" || project == "流通股本（亿股）") {
        return $scope.toDecimal2(value / 100000000);
      } else if (project == "成交金额（万元）" || project == "成交数量（万股）") {
        return $scope.toDecimal2(value / 10000);
      } else {
        return value;
      }
    }


    //产品详情
    $scope.goDetail = function (product, code, type, name, date, path) {
      $scope.detailCode = code;

      if (product != 'china' && type == 0 && path) {
        $scope.openInExternalBrowser(path);
        return;
      }

      switch (product) {
        case 'index':
          {
            $location.path('/marketIndexDetail/' + $scope.detailCode + "/getMarketIndexDetail/" + $scope.categoryMId);
            break;
          }
        case 'stock':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuStockList/getProdStockDetail/");
            break;
          }
        case 'neeq':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuSharetransferList/getProdSharetransferDetail/");
            break;
          }
        case 'hk':
          {
            $location.path("/marketIndexDetail/" + $scope.detailCode + "/getMarketHKDetail/" + $scope.categoryMId);
            break;
          }
        case 'china':
          {
            if (type == "txt") {
              var url = Global.HOST + "/Disclosure/openHtml.do?name=" + name + "&date=" + date + "&path=" + path;
              window.open(url, '_system');
            } else if (type == "html") {
              var url = Global.HOST + path;
              window.open(url, '_system');
            } else if (type == "pdf") {
              var url = Global.WEB + path;
              Toolkit.openFile(url);
            }
            break;
          }

        default:
          {}
      }
    }

    $scope.showAlert = function (msg) {
      var alertPopup = $ionicPopup.alert({
        title: 'title',
        template: msg
      });
    }

    //}}跳转到不同列表

    //{{分类代码处理
    $scope.clearCategory = function () {
      $scope.categoryMId = "";
      $scope.categorySId = "";
      $scope.categoryName = "全部";
      $scope.doRefresh();
      $scope.closePopover();
    }

    $scope.setMcategory = function (key, name) {
      if (key == "301112") {
        $scope.openInExternalBrowser("http://fund.csrc.gov.cn/web/gotListView.statFund");
        return;
      }
      // $scope.viewTitle = name
      $scope.categoryMId = key;
      $scope.categoryName = name;
      $scope.categorySId = "";
      $scope.startDate = "";
      $scope.endDate = "";
      $scope.doRefresh();
      $scope.closePopover();
    };


    $scope.setScategory = function (key, name) {
      if (key == "30111212") {
        $scope.openInExternalBrowser("http://fund.csrc.gov.cn/web/gotListView.statFund");
        return;
      }
      if (key == "30111211") {
        $scope.openInExternalBrowser("http://fund.csrc.gov.cn/web/gotListView.fundInvest");
        return;
      }
      // $scope.viewTitle = name
      $scope.categorySId = key;
      $scope.categoryName = name;
      $scope.categoryMId = "";
      $scope.doRefresh();
      $scope.closePopover();
    };


    $scope.setBoard = function (key, name) {
      $scope.boardCode = key;
      $scope.boardName = name;
      $scope.doRefresh();
      $scope.closePopover();
    };

    //}}


    //--{{过滤条件框
    $scope.popFilter = $ionicPopover.fromTemplateUrl('filter-popover.html', {
      scope: $scope
    });

    $ionicPopover.fromTemplateUrl('filter-popover.html', {
      scope: $scope
    }).then(function (popover) {
      $scope.popFilter = popover;
    });

    $scope.openFilterPopover = function ($event) {
      $scope.popFilter.show($event);
      //$scope.popover.show();
      // $scope.showAlert('点击pop');
    };

    $scope.closePopover = function () {
      $scope.popFilter.hide();
      $scope.popExtra.hide();
    };
    // 清除浮动框
    $scope.$on('$destroy', function () {
      $scope.popFilter.remove();
      $scope.popExtra.remove();
      //todo:other popover remore
    });
    //--}}

    //--{{板块条件框

    $ionicPopover.fromTemplateUrl('board-popover.html', {
      scope: $scope
    }).then(function (popover) {
      $scope.popBoard = popover;
    });

    $scope.openBoardPopover = function ($event) {
      $scope.popBoard.show($event);
      //$scope.popover.show();
      // $scope.showAlert('点击pop');
    };

    //--}}


    //--{{扩展的条件框

    $ionicPopover.fromTemplateUrl('extra-popover.html', {
      scope: $scope
    }).then(function (popover) {
      $scope.popExtra = popover;
    });

    $scope.openExtraPopover = function ($event) {
      $scope.popExtra.show($event);
      //$scope.popover.show();
      // $scope.showAlert('点击pop');
    };

    $scope.setExtra = function (key, name) {
      $scope.extraCode = key;
      if (name != "") {
        $scope.extraName = name;
      } else {
        $scope.extraName = $scope.getAllExtraName($scope.extraMetaCode);
      }
      $scope.doRefresh();
      $scope.closePopover();
    };
    //--}}


    $scope.doRefresh = function () {
      if ($scope.methodList) {
        $scope.pageNo = 1;
        $scope.getAnnuArray(false);
      }

      if ($scope.methodDetail) {
        if ($scope.methodDetail == "getMarketChinaDetail") {
          $scope.openChinaAnnu(Global.HOST + $rootScope.chinaAnnuPath);
          return;
        } else {
          $scope.getDetailData(false);
        }
      }


    }


    $scope.loadMore = function () {
      // 上拉刷新
      if ($scope.methodList) {
        $scope.getAnnuArray(true);
      }
      //   $scope.$broadcast('scroll.infiniteScrollComplete');
    }


    $scope.getAnnuArray = function (isAppend) {
      if (!isAppend) {
        $scope.annuArray = [];
      }
      var stocklist = null;
      var promise = getAnnuService.query({
        method: $scope.methodList,
        keyword: $scope.queryCondition.keyword,
        boardCode: $scope.boardCode,
        typeCode: $scope.boardCode,
        categoryMId: $scope.categoryMId,
        categorySId: $scope.categorySId,
        startDate: $scope.startDate,
        endDate: $scope.endDate,
        pageNo: $scope.pageNo,
        pageSize: $scope.pageSize,
      }).$promise;

      if (!isAppend) {
        $ionicLoading.show();
      }
      promise.then(function (_response) {
        if (!isAppend) {
          $ionicLoading.hide();
        }
        if (_response.status == "1") {
          if (isAppend) {
            $scope.annuArray = $scope.annuArray.concat(_response.list);
          } else {
            $scope.annuArray = _response.list;
            $scope.annuArray.type = "list";
          }
          // if (_response.date) {
          //   $scope.startDate = _response.date;
          // }

          //数据刷新成功后，如果数据不够10条，关闭上拉加载，防止反复触发加载
          $scope.hasMoreData = _response.list.length > 9;
          $scope.pageNo += 1;
        } else if (_response.status == "0") {
          if (isAppend) {
            $scope.hasMoreData = false;
          } else {
            $scope.annuArray = null;
            $scope.hasMoreData = false;
            $scope.listInfo = "没有符合条件的数据";
          }
        } else {
          Toolkit.alert('网络信号不好...');
          $scope.hasMoreData = false;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');
      }, function () {

        if (!isAppend) {
          $ionicLoading.hide();
        }
        Toolkit.alert('网络信号不好...');
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');
        //数据刷新失败后，关闭上拉加载，防止反复触发加载
        $scope.hasMoreData = false;
      });
    };

    $scope.isSupportCode = function () {
      if ($scope.categoryMId == '301214' || $scope.categoryMId == '301215' || $scope.categorySId == '30121112') {
        return false
      } else {
        return true;
      }
    }

    $scope.onChange = function (keyword) {
      if (!$scope.isSupportCode()) {
        return;
      }
      if (keyword.length > 0) {
        $scope.showCodeList = true;
        var channelPath = $scope.categoryMId ? $scope.categoryMId : $scope.baseChannelPath
        SearchSuggestService.query({ keyword: keyword, channelPath: channelPath }).$promise.then(function (_response) {
          if (_response.status == 0) {
            $scope.filterCodeList = [];
            _response.data.forEach(function (v) {
              $scope.filterCodeList.push(v.code + ' ' + v.typeLabel + ' ' + v.name);
            });
          }
        });
      } else {
        $scope.showCodeList = false;
      }
    }


    $scope.getDetailData = function () {
      var stocklist = null;
      var promise = getDetailService.query({
        method: $scope.methodDetail,
        keyword: $scope.queryCondition.keyword,
        boardCode: $scope.boardCode,
        code: $scope.detailCode,
        startDate: $scope.startDate,
        categoryMId: $scope.categoryMId,
      }).$promise;

      $ionicLoading.show();
      promise.then(function (_response) {
        $ionicLoading.hide();
        if (_response.status == "1") {
          $scope.detailData = _response.detail;
          $scope.detailName = _response.name;
          var cleaner = new DOMCleaner(_response.detail.data.content);
          var html = cleaner.clean();
          // var html = dom.html();
          $scope.detailData.data.content = html.trim() ? html : '';
          $scope.showEcharts();
        } else {
          Toolkit.alert('网络信号不好...');
        }
      }, function () {
        $ionicLoading.hide();
        Toolkit.alert('网络信号不好...');
      });
    };

    $scope.openChinaAnnu = function (path) {
      $http({
        method: 'GET',
        url: path
      }).then(
        function successCallback(response) {
          $scope.textData = response.data;
        },
        function errorCallback(response) {
          this.alert('文件存在问题，无法下载');
        });
    };

    $scope.openInExternalBrowser = function (url) {
      var fullUrl = url;
      if (url.indexOf("http://") < 0) {
        var fullUrl = Global.HOST + url;
      }
      Toolkit.openFile(fullUrl);
    };
  })
