/**
 * Created by zhujunchao on 16/5/8.
 */
angular.module('starter.me', ['ionic', 'me.services'])
  .controller('MeCtrl', function ($scope,
    $ionicPopup,
    $location,
    $cordovaDevice,
    $ionicLoading,
    $ionicViewService,
    $ionicActionSheet,
    $state,
    $ionicHistory,
    Login,
    Register,
    Toolkit,
    MyFavoriteList,
    MyMessageList,
    GetValiCodeService,
    GetUserOptionalNewsService,
    Toolkit) {

    $scope.getLogo = 'img/logo.png';
    $scope.myStocks = null;
    $scope.myFunds = null;
    $scope.errorinfo = "";
    $scope.phone = "";
    $scope.valiCodeButtonText = "获取验证码";
    $scope.enableValiCodeButton = true;

    // $scope.uuid = $rootScope.deviceInformation;
    //$scope.device = $cordovaDevice.getDevice();
    //$scope.cordova = $cordovaDevice.getCordova();
    //$scope.model = $cordovaDevice.getModel();
    //$scope.platform = $cordovaDevice.getPlatform();
    //$scope.uuid = $cordovaDevice.getUUID();
    //$scope.version = $cordovaDevice.getVersion();
    
    $scope.valiCodeBtnStyle = {color: "#888"}

    $scope.getUser = function () {
      return Global.User;
    }

    $scope.clickValiCodeBtn = function (phone) {
      if (!$scope.enableValiCodeButton || phone.length != 11) {
        return;
      }
      if (!BaseReg.phone.test(phone)) {
        Toolkit.alert('手机号有误，请重新输入');
        return;
      }
      $scope.enableValiCodeButton = false;
      GetValiCodeService.query({
        phone: phone,
      }).$promise.then(function (_response) {
        var remainTime = 60;
        $scope.valiCodeButtonText = remainTime + 's';
        var timer = setInterval(function () {
          remainTime--;
          if (remainTime < 0) {
            $scope.valiCodeButtonText = '重新获取';
            $scope.enableValiCodeButton = true;
            $scope.$evalAsync();
            clearInterval(timer);
            return;
          }
          $scope.valiCodeButtonText = remainTime + 's';
          $scope.$evalAsync();
        }, 1000);
      });
    }

    $scope.onPhoneChange = function(phone) {
      if (!phone || phone.length != 11) {
        $scope.valiCodeBtnStyle = {color: "#888"}
      } else {
        $scope.valiCodeBtnStyle = {}
      }
    }

    $scope.registerBtnClick = function (username, phone, valiCode, password) {
      $scope.errorinfo = null;
      if (username == null || username.length < 5 || username.length > 20) {
        $scope.errorinfo = '用户名为6-20位';
        return;
      }
      if (password == null || password.length < 6 || password.length > 20) {
        $scope.errorinfo = '密码为6-20位';
        return;
      }

      if (!BaseReg.phone.test(phone)) {
        $scope.errorinfo = '手机号有误';
        return;
      }

      if (!BaseReg.valiCode.test(valiCode)) {
        $scope.errorinfo = '验证码有误';
        return;
      }

      $ionicLoading.show();
      var promise = Register.get({
        username: username,
        password: password,
        mobile: phone,
        valiCode: valiCode
      }).$promise;
      promise.then(function (_response) {
        if (_response.status == "1") {
          Toolkit.alert('注册成功:' + username);
          Global.User = _response.user;

          window.localStorage.setItem("user", JSON.stringify(Global.User));

          $location.path('/tab/me');
        } else {
          Toolkit.alert(_response.msg);
        }

        $ionicLoading.hide();
      }, function () {
        $ionicLoading.hide();
        Toolkit.alert('网络信号不好...');
      });
    }


    $scope.logout = function () {
      var confirmPopup = $ionicPopup.confirm({
        title: '提示',
        template: '是否退出登录？',
        cancelText: '取消',
        okText: '退出'
      });
      confirmPopup.then(function (res) {
        if (res) {
          Global.User = null;
          window.localStorage.removeItem("user");

          $location.path('/tab/home');
        }
      });
    }

    $scope.goBack = function () {
      $ionicHistory.goBack();
    }

    $scope.goHome = function () {
      $location.path('/tab/home');
    }

    $scope.loginBtnClick = function (username, password) {
      if (typeof (password) == 'undefined') {
        Toolkit.alert('请输入用户名');
        return false;
      } else if (typeof (password) == 'undefined') {
        Toolkit.alert('请输入密码');
        return false;
      } else {

        $ionicLoading.show();

        var promise = Login.get({
          username: username,
          tPassword: password
        }).$promise;
        promise.then(function (_response) {
          if (_response.status == "1") {
            //Toolkit.alert('登录成功'+username);
            Global.User = _response.user;

            window.localStorage.setItem("user", JSON.stringify(Global.User));
            $ionicViewService.nextViewOptions({
              disableAnimate: true,
              disableBack: true
            });

            $location.path('/tab/me');
          } else {
            Toolkit.alert('用户名或密码错误:)');
          }

          $ionicLoading.hide();
        }, function () {

          $ionicLoading.hide();
          Toolkit.alert('网络信号不好...');
        });

      }
    }


    $scope.$on("$ionicView.enter", function (event, data) {
      console.log(data, $scope)
      switch (data.stateName) {
        case 'tab.myFavorite':
          $scope.productType = data.stateParams.product;
          //向服务器请求刷新数据
          $scope.doRefresh();
          break;
        case 'tab.myMessage':
          $scope.doRefreshMessage();
          break;
        case 'tab.news':
          GetUserOptionalNewsService.query({
            userId:Global.User.userId
          }).$promise.then(function(_response) {
            console.log(_response);
            $scope.optionalNews = _response.list;
            if (!_response.list || !_response.list.length) {
              Toolkit.alert('暂无订阅公告更新');
            }
          });
          break;
        case 'tab.register':
          $scope.phone = ""
          $scope.username = ""
          $scope.valiCode = ""
          $scope.password = ""
          break;
      }
    });

    $scope.doRefresh = function () {
      var userid = "";
      var password = "";
      if (Global.User) {
        userid = Global.User.userId;
        password: Global.User.mPassword
      } else {

        $location.path('/tab/login');
      }
      var pt = "";

      if ($scope.productType == 1)
        pt = "01";
      else if ($scope.productType == 2) {
        pt = "02";
      }


      var promise = MyFavoriteList.query({
        userId: userid,
        mPassword: password,
        type: pt
      }).$promise;
      promise.then(function (_response) {
        if (_response.status == "1") {
          if ($scope.productType == 1)
            $scope.myStocks = _response.list;
          else if ($scope.productType == 2) {
            $scope.myFunds = _response.list;
          }
        } else if (_response.status == "0") {
          Toolkit.alert('无自选产品，请添加自选产品');
        } else {
          Toolkit.alert('用户名或密码错误 (:');
        }
      }, function () {
        Toolkit.alert('网络信号不好...');
      });

    }

    $scope.doRefreshMessage = function () {
      var userid = "";
      var password = "";
      if (Global.User) {
        userid = Global.User.userId;
        password: Global.User.mPassword
      } else {
        $location.path('/tab/login');
      }


      var promise = MyMessageList.query({
        userId: userid,
        mPassword: password
      }).$promise;
      promise.then(function (_response) {
        if (_response.status == "1") {
          $scope.myMessages = _response.list;
        }
      }, function () {
        Toolkit.alert('网络信号不好...');
      });
    }

    $scope.goMyStocks = function () {

      $location.path('/tab/myFavorite/1');
    }

    $scope.goMyFunds = function () {

      $location.path('/tab/myFavorite/2');
    }

    $scope.message = function () {

      $location.path('/tab/myMessage');
    }


    $scope.goRegister = function () {
      $location.path('/tab/register');
    }

    $scope.goGetPwd = function () {
      $location.path('/tab/getPwd');

    }



    //产品详情
    $scope.goDetail = function (product, code) {
      switch (product) {
        case 'stock':
          {
            $location.path('/stockDetail/' + code + "/getAnnuStockList/getProdStockDetail/");
            break;
          }
        case 'fund':
          {
            $location.path('/stockDetail/' + code + "/getAnnuFundList/getProdFundDetail/201210");
            break;
          }
        default:
          {}
      }
    }

    //分享
    $scope.share = function () {
      // Show the action sheet
      var hideSheet = $ionicActionSheet.show({
        buttons: [
          { text: '微博' },
          { text: '微信' },
          { text: 'QQ' }
        ],
        // destructiveText: 'Delete',
        titleText: '分享',
        cancelText: '取消',
        cancel: function () {
          // add cancel code..
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.shareWithWeibo();
              break;
            case 1:
              $scope.shareWithWechat();
              break;
            case 2:
              $scope.shareWithQQ();
              break;
          }
          return true;
        }
      });
    }

    $scope.shareWithWeibo = function () {
      var args = {
        url: 'http://www.seid.org.cn/',
        title: '资本市场统一披露平台',
        description: '资本市场统一披露平台',
        image: 'http://www.seid.org.cn/skin/pms/default/images/zlg.png'
      };
      WeiboSDK.checkClientInstalled(function () {
        WeiboSDK.shareToWeibo(function () {
          // alert('分享成功！');
        }, function (failReason) {
          // alert(failReason);
        }, args);
      }, function () {
        Toolkit.alert('未安装微博客户端,无法分享');
      });
    }

    $scope.shareWithWechat = function () {
      Wechat.isInstalled(function (installed) {
        Wechat.share({
          message: {
            title: "资本市场统一披露平台",
            description: "资本市场统一披露平台",
            thumb: "http://www.seid.org.cn/skin/pms/default/images/zlg.png",
            mediaTagName: "TEST-TAG-001",
            messageExt: "这是第三方带的测试字段",
            messageAction: "<action>dotalist</action>",
            media: {
              type: Wechat.Type.WEBPAGE,
              webpageUrl: "http://www.seid.org.cn/"
            }
          },
          scene: Wechat.Scene.TIMELINE // share to Timeline
        }, function () {
          // alert('分享成功！');
        }, function (reason) {
          // alert(reason);
        });
      }, function (reason) {
        Toolkit.alert('未安装微信客户端,无法分享');
      });
    }

    $scope.shareWithQQ = function () {
      QQSDK.checkClientInstalled(function () {
        QQSDK.shareNews(function () {
          // alert('分享成功！');
        }, function (failReason) {
          // alert(failReason);
        }, {
          client: QQSDK.ClientType.QQ,
          scene: QQSDK.Scene.QQZone, //QQSDK.Scene.QQ,QQSDK.Scene.QQZone,QQSDK.Scene.Favorite
          url: 'http://www.seid.org.cn/',
          title: '资本市场统一披露平台',
          description: '资本市场统一披露平台',
          image: 'http://www.seid.org.cn/skin/pms/default/images/zlg.png'
        });
      }, function () {
        Toolkit.alert('未安装QQ客户端,无法分享');
      }, {
        client: QQSDK.ClientType.QQ //QQSDK.ClientType.QQ,QQSDK.ClientType.TIM;
      });
    }

    $scope.GoQQLoginIn = function () {
      YCQQ.checkClientInstalled(function () {
        console.log('client is installed');
        var checkClientIsInstalled = 0; //default is 0,only for iOS
        YCQQ.ssoLogin(function (args) {
          alert(args.access_token);
          alert(args.userid);
        }, function (failReason) {
          alert(failReason);
        }, checkClientIsInstalled);
      }, function () {
        // if installed QQ Client version is not supported sso,also will get this error
        console.log('client is not installed');
        alert('未安装QQ客户端,无法登录');
      });
    }

    $scope.GoWeiBoLoginIn = function () {
      YCWeibo.checkClientInstalled(function () {
        console.log('client is installed');
        YCWeibo.ssoLogin(function (args) {
          alert(args.access_token);
          alert(args.userid);
        }, function (failReason) {
          console.log(failReason);
          alert(failReason);
        });
      }, function () {
        console.log('client is not installed');
        alert('未安装微博客户端,无法登录');
      });
    }

    $scope.openInExternalBrowser = function (url, type, name, date) {
      if (type == "txt") {
        var fullUrl = Global.HOST + "/Disclosure/openHtml.do?name=" + name + "&date=" + date + "&path=" + url;

        window.open(fullUrl, '_system');
      } else if (type == "xbrl") {
        var fullUrl = Global.XBRLHOST + url;
        window.open(fullUrl, '_system');
      } else {
        var fullUrl = url;
        if (url.indexOf("http://") < 0) {
          var fullUrl = Global.WEB + url;
        }

        Toolkit.openFile(fullUrl);
      }
    };

  })
