/**
 * Created by zhujunchao on 16/5/25.
 */
angular.module('me.services', [])
  .factory('saveLocalServices', ['$window', function ($window) {
    return {
      //存储单个属性
      set: function (key, value) {
        $window.localStorage[key] = value;
      },
      //读取单个属性
      get: function (key, defaultValue) {
        return $window.localStorage[key] || defaultValue;
      },
      //存储对象，以JSON格式存储
      setObject: function (key, value) {
        $window.localStorage[key] = JSON.stringify(value);
      },
      //读取对象
      getObject: function (key) {
        return JSON.parse($window.localStorage[key] || '{}');
      }

    }
  }])
  .factory('GetValiCodeService', function ($resource) {
    return $resource(Global.HOST + '/Disclosure/getValiCode.do', {
      phone: '@phone'
    }, {
      query: {
        method: 'POST',
        isArray: false,
        header: { 'Access-Control-Allow-Origin': "*" }
      }
    });
  })
  .factory('GetUserOptionalNewsService', function ($resource) {
    return $resource(Global.HOST + '/Disclosure/getUserOptionalNews.do', {
      userId: '@userId'
    }, {
      query: {
        method: 'POST',
        isArray: false,
        header: { 'Access-Control-Allow-Origin': "*" }
      }
    });
  });
