/**
 * Created by zhujunchao on 16/5/8.
 */
angular.module('starter.products', [
    'ionic',
    'ngCordova',
    'ngResource',
    'public.services',
    "integralui",
    "starter.services"
  ])
  .controller('ProductsCtrl', function($scope, $rootScope,
    $ionicTabsDelegate,
    $location,
    $ionicPopup,
    $stateParams,
    $ionicPopover,
    $ionicHistory, $sce, $ionicLoading,
    ionicDatePicker,

    getAnnuService,
    getDetailService,
    getAnnuCategoryService,
    Toolkit,
    AddFavorite,
    SearchSuggestService
  ) {
    $scope.queryCondition = {
      keyword: "",
    };

    $scope.keyword = "";
    $scope.boardCode = "";
    $scope.categoryMId = "";
    $scope.categorySId = "";
    $scope.startDate = "";
    $scope.endDate = "";
    $scope.pageNo = 1;
    $scope.pageSize = 20;

    $scope.methodList = null;
    $scope.annuArray = null;


    $scope.methodDetail = null;
    $scope.detailData = null;

    //$rootScope.categoryDic=null;
    $scope.category = null;
    $scope.categoryName = "全部";

    $scope.board = null;
    $scope.boardName = "上市地";

    $scope.extra = null;
    $scope.extraName = "类别";

    $scope.showCodeList = false;
    $scope.filterCodeList = new Array();
    $scope.data = {
      isSupportCode: true, //是否支持代码提示
    };
    $scope.baseChannelPath = '';

    $scope.listInfo = "正在加载...";
    //--------------------------------------------------------------------------下方是不同view的分别处理-------------------------------------------------------------------------

    $scope.formatNumber = function(number, format) {
      return d3.format(format)(number);
    }

    $scope.formatDate = function(dateString, format) {
      return moment(dateString).format(format);
    }

    $scope.isHtml = function(str) {
      return /<[^>]+>/g.test(str);
    }

    $scope.getCategoryMName = function() {

        if (!$scope.category) return null;

        for (var i = 0; i < $scope.category.length; i++) {
          if ($scope.categoryMId == $scope.category[i].key) {
            return $scope.category[i].value;
          }
        }
        return "全部";
      }
      //视图进入后的事件，设置对应的分类对象代码和板块对象代码
    $scope.$on("$ionicView.afterEnter", function(event, data) {
      // handle event
      $rootScope.jumpFromHome = false;
    })

    //视图进入后的事件，设置对应的分类对象代码和板块对象代码
    $scope.$on("$ionicView.enter", function(event, data) {
      // handle event
      switch (data.stateName) { //公告相关
        //产品列表
        case 'tab.stockProList':
          {
            $scope.baseChannelPath = data.stateParams.channelPath;
            // if (data.direction != "forward" && !$rootScope.jumpFromHome) {
            //   return;
            // }
            //清空接口方法
            $scope.methodList = null;
            $scope.methodDetail = null;
            $scope.categoryCode = null;
            $scope.categoryCode = data.stateParams.category;
            $scope.category = Toolkit.getCategory(data.stateParams.category);

            $scope.board = Toolkit.getCategory(data.stateParams.board);
            $scope.boardMetaCode = data.stateParams.board;
            $scope.baseBoardMetaCode = data.stateParams.board;
            $scope.categoryMId = data.stateParams.categoryMId;
            $scope.categoryName = $scope.getCategoryMName();
            $scope.methodList = data.stateParams.method;
            $scope.viewTitle = data.stateParams.title;
            $scope.queryCondition.keyword = data.stateParams.keyword;

            if (data.stateParams.extra) {

              $scope.extra = Toolkit.getCategory(data.stateParams.extra);

              //不同产品的选择条件名称不同
              $scope.extraName = $scope.getAllExtraName(data.stateParams.extra);
              $scope.extraMetaCode = data.stateParams.extra;
              $scope.baseExtraMetaCode = data.stateParams.extra;
              // 互证基金
              if (data.stateParams.category == '9587') {
                $scope.extraCode = $scope.extra[0].key;
                $scope.extraName = $scope.extra[0].value;
              }
            }

            //不同产品的选择条件名称不同
            $scope.boardName = $scope.getAllBoardName(data.stateParams.board);

            if ($scope.methodList == "getProdStockList") {
              $scope.codeList = Global.ProductCodes.stocks;
            } else if ($scope.methodList == "getProdFundList") {
              $scope.codeList = Global.ProductCodes.funds;
            } else if ($scope.methodList == "getProdBondList") {
              $scope.codeList = Global.ProductCodes.bonds;
            } else if ($scope.methodList == "getProdSharetransferList") {
              $scope.codeList = Global.ProductCodes.sharetransfer;
            }
            $scope.setIsSupporceCode();
            break;
          }

          //产品详情
        case 'stockDetail':
          {
            //清空接口方法
            $scope.methodList = null;
            $scope.methodDetail = null;
            $scope.methodList = data.stateParams.methodList;
            $scope.methodDetail = data.stateParams.methodDetail;
            $scope.detailCode = data.stateParams.code;
            $scope.queryCondition.keyword = data.stateParams.code;
            $scope.categoryMId = data.stateParams.categoryMId;
            break;
          }

      }

      if ($scope.methodList) {
        //初始状态时，阻止下拉刷新
        $scope.hasMoreData = false;
      }

      //向服务器请求刷新数据
      $scope.doRefresh();
    });

    $scope.showExtra = function() {
      if (!$scope.extra) {
        return false;
      }
      if ($scope.categoryMId == "201110" || $scope.categoryMId == "201111" || $scope.categoryMId == "201211" || $scope.categoryMId == "201212" || $scope.categoryMId == "201213") {
        return false;
      }
      return true;
    }

    /*....遗留bug...*/

      // $scope.boards=function () {
      //   if (!$scope.board){
      //     return false
      //   }
      //   if ($scope.categorySId =='101311' && $scope.categorySId =='101310'){
      //     return false;
      //   }else {
      //     return true;
      //   }
      // }

    $scope.toDecimal2 = function(m) {
      return Toolkit.toDecimal2(m);
    }

    //产品列表
    $scope.goProductList = function(name) {
      switch (name) {
        case 'stock':
          {
            $location.path('/tab/stockProList/getProdStockList/9584/13/上市公司/0/201010/2010/');
            break;
          }
        case 'neeq':
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        {
            $location.path('/tab/stockProList/getProdSharetransferList/9585/38/非上市公众公司/15/201110/2011/');
            break;
          }
        case 'fund':
          {
            $location.path('/tab/stockProList/getProdFundList/9586/19/公募基金/21/201210/2012/');
            break;
          }
        case 'mutual':
          {
            $location.path('/tab/stockProList/getProdFundMutualList/9587/00/互认基金/16//2013/');
            break;
          }
        case 'bond':
          {
            $location.path('/tab/stockProList/getProdBondList/9588/02/债券/0/201410/2014/');
            break;
          }
        case 'abs':
          {
            $location.path('/tab/stockProList/getProdAbsList/9589/0/资产支持证券/25/201510/2015/');
            break;
          }
        case 'private':
          {
            $location.path('/tab/stockProList/getProdPrivatefundList/9590/09/私募基金/0/201610/2016/');
            break;
          }
        case 'agency':
          {
            $location.path('/tab/stockProList/getRegularFirmList/9592/00/中介机构/0/201810/2018/');
            break;
          }
          // case 'warran':
          //   {
          //     $location.path('/tab/stockProList/getProdWarrantList/9591/03/权证/0/');
          //     break;
          //   }
        default:
          {}
      }
    }

    //产品详情
    $scope.goDetail = function(product, code, categoryMId) {
      $scope.detailCode = code;
      switch (product) {
        case 'stock':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuStockList/getProdStockDetail/");
            break;
          }
        case 'neeq':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuSharetransferList/getProdSharetransferDetail/" + (categoryMId ? categoryMId : $scope.categoryMId));
            break;
          }
        case 'fund':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuFundList/getProdFundDetail/" + (categoryMId ? categoryMId : $scope.categoryMId));
            //$location.path('/stockDetail/'+$scope.detailCode+"/getAnnuFundList/getProdFundDetail/");
            break;
          }
        case 'mutual':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuFundMutualList/getProdFundMutualDetail/");
            break;
          }
        case 'bond':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuBondList/getProdBondDetail/" + $scope.categoryMId);
            break;
          }
        case 'abs':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuAbsList/getProdAbsDetail/" + $scope.categoryMId);
            break;
          }
        case 'private':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "//getProdPrivatefundDetail/" + $scope.categoryMId);
            break;
          }
          // case 'warran':
          //   {
          //     $location.path('/stockDetail/' + $scope.detailCode + "/getAnnuWarrantList/getProdWarrantDetail/");
          //     break;
          //   }
        case 'agency':
          {
            $location.path('/stockDetail/' + $scope.detailCode + "//getRegularFirmDetail/" + $scope.categoryMId);
          }
        default:
          {}
      }
    }

    $scope.getDetailValueList = function(code, classCode) {
      var valueList = $scope.detailData.valueList;
      var value = null;
      for (var i = 0; i < valueList.length; i++) {
        if (valueList[i].classCode == classCode) {
          value = valueList[i];
          break
        }
      }
      getAnnuService.query({
        method: 'getAnnuFundList',
        keyword: code,
        classCode: classCode ? classCode : 'null',
        categorySId: categorySId,
        pageNo: Math.ceil(value.classList.length / 5) + 1,
        pageSize: 5,
      }).$promise.then(function(_response) {
        _response.list.forEach(function(v) {
          value.classList.push(v);
        })
      });
    }

    $scope.showAlert = function(msg) {
      var alertPopup = $ionicPopup.alert({
        title: '提示',
        template: msg
      });
    }

    //分类代码处理
    $scope.clearCategory = function() {
      $scope.categoryMId = "";
      $scope.categorySId = "";
      $scope.categoryName = "全部";
      $scope.doRefresh();
      $scope.closePopover();
    }

    $scope.setIsSupporceCode = function() {
      $scope.data.isSupportCode = (["9584", "9585", "9586", "9587", "9588", "9589"].indexOf($scope.categoryCode) > -1 && ['201111', "201213", "201212"].indexOf($scope.categoryMId.toString()) < 0);
    }

    $scope.setMcategory = function(key, name) {
      $scope.categoryMId = key;
      $scope.categoryName = name;
      $scope.data.isSupportCode = true;

      $scope.boardCode = "";
      $scope.boardMetaCode = $scope.baseBoardMetaCode;
      $scope.board = Toolkit.getCategory($scope.boardMetaCode);
      $scope.boardName = $scope.getAllBoardName($scope.boardMetaCode);
      $scope.extraCode = "";
      $scope.extraMetaCode = $scope.baseExtraMetaCode;
      $scope.extra = Toolkit.getCategory($scope.extraMetaCode);
      $scope.extraName = $scope.getAllExtraName($scope.extraMetaCode);

      if ($scope.categoryMId == "201211" || $scope.categoryMId == "201212" || $scope.categoryMId == "201213") {
        $scope.extraCode = "";
      }

      // 非上市公司-挂牌公司
      if ($scope.categoryMId == "201110") {
        $scope.boardCode = "";
        $scope.boardName = $scope.getAllBoardName("38");
        $scope.board = Toolkit.getCategory("38");
        $scope.boardMetaCode = "38";
        $scope.extraCode = "";
      }

      // 非上市公司-非挂牌公司
      if ($scope.categoryMId == "201111") {
        $scope.boardCode = "";
        $scope.boardName = "";
        $scope.board = null;
        $scope.boardMetaCode = "";
        $scope.extraCode = "";
      }

      // 非上市公司-两网退市公司
      if ($scope.categoryMId == "201112") {
        $scope.boardCode = "";
        $scope.boardName = "";
        $scope.board = null;
        $scope.boardMetaCode = "";
        $scope.extraCode = "";
      }

      // 上市公司
      if ($scope.categoryMId.toString().indexOf('2010') > -1) {
        if ($scope.categoryMId == "201012" || $scope.categoryMId == "201013") {
          // 中小板和创业板不显示股票类型
          $scope.boardName = "";
          $scope.board = null;
          $scope.boardCode = "";
        } else {
          $scope.board = Toolkit.getCategory('13');
          $scope.boardName = $scope.getAllBoardName('13');
          $scope.boardCode = "";
        }
      }

      if ($scope.categoryMId == "201210") {
        $scope.boardCode = "";
        $scope.boardName = $scope.getAllBoardName("19");
        $scope.board = Toolkit.getCategory("19");
        $scope.boardMetaCode = "19";

        $scope.extra = Toolkit.getCategory("21");
        //不同产品的选择条件名称不同
        $scope.extraName = $scope.getAllExtraName("21");
        $scope.extraMetaCode = "21";
      }

      if ($scope.categoryMId == "201211") {
        $scope.boardCode = "";
        $scope.boardName = $scope.getAllBoardName("24");
        $scope.board = Toolkit.getCategory("24");
        $scope.boardMetaCode = "24";
      }

      if ($scope.categoryMId == "201212") {
        $scope.boardCode = "";
        $scope.boardName = $scope.getAllBoardName("06");
        $scope.board = Toolkit.getCategory("06");
        $scope.boardMetaCode = "06";
      }

      if ($scope.categoryMId == "201611") {
        $scope.boardCode = "";
        $scope.boardName = $scope.getAllBoardName("11");
        $scope.board = Toolkit.getCategory("11");
        $scope.boardMetaCode = "11";
      }

      if ($scope.categoryMId == "201612") {
        $scope.boardCode = "";
        $scope.boardName = $scope.getAllBoardName("43");
        $scope.board = Toolkit.getCategory("43");
        $scope.boardMetaCode = "43";
      }

      // 证券公司私募产品
      if ($scope.categoryMId == "201613") {
        $scope.boardCode = "";
        $scope.boardName = "";
        $scope.board = null;
        $scope.boardMetaCode = "";
      }

      if ($scope.categoryMId == "201213") {
        $scope.board = null;
      }

      $scope.setIsSupporceCode();
      $scope.doRefresh();
      $scope.closePopover();

    };


    $scope.setScategory = function(key, name) {
      $scope.categorySId = key;
      $scope.categoryName = name;
      $scope.doRefresh();
      $scope.closePopover();
    };

    $scope.getAllBoardName = function(boardCategoryCode) {
      if (boardCategoryCode == "02" || boardCategoryCode == "25") {
        return "上市地";
      } else if (boardCategoryCode == "19") {
        return "运作方式";
      } else if (boardCategoryCode == "13") {
        return "股票类型";
      } else if (boardCategoryCode == "09") {
        return "运转状态";
      } else if (boardCategoryCode == "16") {
        return "基金类型";
      } else if (boardCategoryCode == "24") {
        return "管理人类型";
      } else if (boardCategoryCode == "06") {
        return "销售机构类型";
      } else if (boardCategoryCode == "11") {
        return "主要投资基金类型";
      } else if (boardCategoryCode == "38") {
        return "转让类型";
      } else if (boardCategoryCode == "43") {
        return "专户类型";
      } else {
        return "板块";
      }
    }

    $scope.setBoard = function(key, name) {
      $scope.boardCode = key;
      if (name != "")
        $scope.boardName = name;
      else
        $scope.boardName = $scope.getAllBoardName($scope.boardMetaCode);

      $scope.doRefresh();
      $scope.closePopover();
    };

    $scope.getAllExtraName = function(extraCategoryCode) {

      if (extraCategoryCode == "21" || extraCategoryCode == "16") {
        return "基金类型";
      }
      if (extraCategoryCode == "15") {
        return "股票类型";
      } else if (extraCategoryCode == "") {
        return "运作方式";
      } else if (extraCategoryCode == "25") {
        return "上市地";
      } else {
        return "板块";
      }
    }

    $scope.setExtra = function(key, name) {
      $scope.extraCode = key;
      if (name != "")
        $scope.extraName = name;
      else
        $scope.extraName = $scope.getAllExtraName($scope.extraMetaCode);

      $scope.doRefresh();
      $scope.closePopover();
    };

    //}}



    $scope.goForward = function() {
      var selected = $ionicTabsDelegate.selectedIndex();
      if (selected != -1) {
        $ionicTabsDelegate.select(selected + 1);
      }
    }

    $scope.goBack = function() {

      if ($scope.methodDetail == null) {
        $location.path("/tab/products")
      } else {
        $ionicHistory.goBack();
      }
    }


    //--{{下拉代码条件框

    //--{{下拉代码条件框
    $scope.onChange = function(keyword) {
      if (!$scope.data.isSupportCode) {
        return
      }

      if (keyword.length > 0) {
        $scope.showCodeList = true;
        var channelPath = $scope.categoryMId ? $scope.categoryMId : $scope.baseChannelPath
        SearchSuggestService.query({
          keyword: keyword,
          channelPath: channelPath
        }).$promise.then(function(_response) {
          if (_response.status == 0) {
            $scope.filterCodeList = [];
            _response.data.forEach(function(v) {
              $scope.filterCodeList.push(v.code + (v.typeLabel == "基金管理人" ? '' : ' ' + v.typeLabel) + ' ' + v.name);
            });
          }
        });
      } else {
        $scope.showCodeList = false;
      }
    };

    $scope.setQueryCode = function(code) {
      if (code) {
        var index = code.indexOf(" ");
        $scope.queryCondition.keyword = code.substring(0, index);
      }
      $scope.closePopover();
      $scope.showCodeList = false;
    }

    $scope.search = function() {
      if ($scope.showCodeList) {
        $scope.setQueryCode($scope.filterCodeList[0]);
        // $scope.setQueryCode($scope.filterCodeList[1]);
      }

      $scope.showCodeList = false;
      $scope.doRefresh();
    }


    $scope.trustHtml = function(data) {
      return $sce.trustAsHtml(data);
    }

    //--}} 下拉代码条件框
    //--}} 下拉代码条件框


    //--{{过滤条件框


    $ionicPopover.fromTemplateUrl('filter-popover.html', {
      scope: $scope
    }).then(function(popover) {
      $scope.popFilter = popover;
    });

    $scope.openFilterPopover = function($event) {
      $scope.popFilter.show($event);
      //$scope.popover.show();
      // $scope.showAlert('点击pop');
    };

    $scope.closePopover = function() {
      $scope.popFilter.hide();
      $scope.popBoard.hide();
      $scope.popExtra.hide();
    };
    // 清除浮动框
    $scope.$on('$destroy', function() {
      $scope.popFilter.remove();
      $scope.popBoard.remove();
      $scope.popExtra.remove();
      //todo:other popover remore
    });
    //--}}

    //--{{板块条件框

    $ionicPopover.fromTemplateUrl('board-popover.html', {
      scope: $scope
    }).then(function(popover) {
      $scope.popBoard = popover;
    });

    $scope.openBoardPopover = function($event) {
      $scope.popBoard.show($event);
      //$scope.popover.show();
      // $scope.showAlert('点击pop');
    };

    //--}}


    //--{{扩展的条件框

    $ionicPopover.fromTemplateUrl('extra-popover.html', {
      scope: $scope
    }).then(function(popover) {
      $scope.popExtra = popover;
    });

    $scope.openExtraPopover = function($event) {
      $scope.popExtra.show($event);
      //$scope.popover.show();
      // $scope.showAlert('点击pop');
    };

    //--}}


    $scope.doRefresh = function() {

      if ($scope.methodList) {
        $scope.pageNo = 1;
        $scope.getAnnuArray(false);
      }

      if ($scope.methodDetail) {
        $scope.getDetailData(false);
      }

    }


    $scope.loadMore = function() {
      // 上拉刷新
      if ($scope.methodList) {
        $scope.getAnnuArray(true);
      }
      //   $scope.$broadcast('scroll.infiniteScrollComplete');
    }


    $scope.getAnnuArray = function(isAppend) {
      var stocklist = null;
      var MID = $scope.categoryMId;
      if ($scope.methodDetail) {
        MID = "";
      }
      var promise = getAnnuService.query({
        method: $scope.methodList,
        keyword: $scope.queryCondition.keyword,
        boardCode: $scope.boardCode,
        extraCode: $scope.extraCode,
        categoryMId: MID,
        categorySId: $scope.categorySId,
        startDate: $scope.startDate,
        endDate: $scope.endDate,
        pageNo: $scope.pageNo,
        pageSize: $scope.pageSize,
      }).$promise;

      if (!isAppend) {
        $ionicLoading.show();
      }
      promise.then(function(_response) {
        if (!isAppend) {
          $ionicLoading.hide();
        }
        if (_response.status == "1") {
          if (isAppend) {
            $scope.annuArray = $scope.annuArray.concat(_response.list);
          } else {
            $scope.annuArray = _response.list;
          }
          //数据刷新成功后，如果数据不够10条，关闭上拉加载，防止反复触发加载
          $scope.hasMoreData = _response.list.length > 9;
          $scope.pageNo += 1;
        } else if (_response.status == "0") {
          if (isAppend) {
            $scope.hasMoreData = false;
          } else {
            $scope.annuArray = null;
            $scope.hasMoreData = false;
            $scope.listInfo = "没有符合条件的数据";
          }
        } else {
          Toolkit.alert('网络信号不好...');
          $scope.hasMoreData = false;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');
      }, function() {

        if (!isAppend) {
          $ionicLoading.hide();
        }
        Toolkit.alert('网络信号不好...');
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');
        //数据刷新失败后，关闭上拉加载，防止反复触发加载
        $scope.hasMoreData = false;
      });
    };


    $scope.getDetailData = function() {
      var stocklist = null;
      var userid = "";
      if (Global.User != null) {
        userid = Global.User.userId;
      }

      var promise = getDetailService.query({
        method: $scope.methodDetail,
        keyword: $scope.queryCondition.keyword,
        boardCode: $scope.boardCode,
        code: $scope.detailCode,
        date: $scope.startDate,
        categoryMId: $scope.categoryMId,
        userId: userid,
      }).$promise;

      $ionicLoading.show();
      promise.then(function(_response) {
        $ionicLoading.hide();
        if (_response.status == "1") {
          $scope.detailData = _response.detail;
        } else {
          $scope.detailData = _response.detail;
          $scope.showAlert('网络信号不好...');
        }
      }, function() {
        $ionicLoading.hide();
        $scope.showAlert('网络信号不好...');
      });
    };


    $scope.doFavorite = function() {
      var userid = "";
      var password = "";
      if (Global.User) {
        userid = Global.User.userId;
        password: Global.User.mPassword
      } else {

        $location.path('/tab/login');
        return;
      }

      var type = '00';
      if ($scope.methodDetail == 'getProdStockDetail') {

        type = '01';
      } else if ($scope.methodDetail == 'getProdFundDetail') {
        type = '02';
      }
      var tag = '01';
      if ($scope.detailData.isfavorite == 1) {
        tag = '02';
      }
      var promise = AddFavorite.set({
        userId: userid,
        mPassword: password,
        optionalId: $scope.detailData.id,
        type: type,
        tag: tag
      }).$promise;
      promise.then(function(_response) {
        if (_response.status == "1") {
          if ($scope.detailData.isfavorite == 0) {
            $scope.detailData.isfavorite = 1;
            $scope.showAlert('添加自选成功:)');
          } else {
            $scope.detailData.isfavorite = 0;
            $scope.showAlert('取消自选成功:)');
          }
        } else if (_response.status == "0") {
          $scope.showAlert('操作自选失败(:');
        } else {
          $scope.showAlert('用户名或密码错误 (:');

        }
      }, function() {
        Toolkit.alert('网络信号不好(:');
      });
    }


    $scope.openInExternalBrowser = function(url, type, date) {
      if (type == "txt") {
        var fullUrl = Global.HOST + "/Disclosure/openHtml.do?name=" + name + "&date=" + date + "&path=" + url;
        window.open(fullUrl, '_system');
      } else if (type == "xbrl") {
        var fullUrl = Global.XBRLHOST + url;
        window.open(fullUrl, '_system');
      } else {
        var fullUrl = url;
        if (url.indexOf("http://") < 0) {
          var fullUrl = Global.WEB + url;
        }
        Toolkit.openFile(fullUrl);
      }
    };
  })
