/**
 * Created by zhujunchao on 16/5/8.
 */
angular.module('starter.public', ['ionic',
    'ngCordova',
    'ngResource',
    'public.services',
    "integralui",
    'starter.services'
  ])
  .controller('PublicCtrl', function ($scope,
    $rootScope,
    $ionicTabsDelegate,
    $location,
    $ionicPopup,
    $stateParams,
    $ionicPopover,
    $ionicPlatform,
    $ionicLoading,
    $cordovaFileTransfer,
    $cordovaFile,
    $cordovaFileOpener2,
    $http,
    $ionicHistory,
    ionicDatePicker,
    getAnnuService,
    getDetailService,
    getAnnuCategoryService,
    SearchSuggestService,
    Toolkit) {
    $scope.queryCondition = {
      keyword: "",
    };

    $scope.keyword = "";
    $scope.boardCode = "";
    $scope.disclosureType = "";
    $scope.disclosureTypeName = "";
    $scope.board1Code = "";
    $scope.categoryMId = "";

    $scope.categorySId = "";
    $scope.startDate = "";
    $scope.endDate = "";
    $scope.pageNo = 1;
    $scope.pageSize = 20;
    $scope.baseChannelPath = '';

    $scope.methodList = null;
    $scope.annuArray = null;

    $scope.methodDetail = null;
    $scope.detailData = null;

    $scope.categoryCode = "";
    //$rootScope.categoryDic=null;
    $scope.category = null;
    $scope.categoryName = "全部";

    $scope.board = null;
    $scope.boardName = "上市地";
    // $scope.boardName = "";

    $scope.board1 = null;
    $scope.board1Name = "";

    $scope.board2=null;
    $scope.board2Name="新需求"

    $scope.showCodeList = false;
    $scope.filterCodeList = new Array();

    $scope.listInfo = "正在加载...";
    $scope.data = {
      strings: {
        placeholder: "",
      }
    };



    //--------------------------------------------------------------------------下方是不同view的分别处理-------------------------------------------------------------------------
    $scope.getCategoryMName = function () {
      for (var i = 0; i < $scope.category.length; i++) {
        if ($scope.categoryMId == $scope.category[i].key) {
          return $scope.category[i].value;
        }
        if ($scope.categoryMId == '1010') {
          return "上市板块"
        }
        // if ($scope.categoryMId == '1011') {
        //    return "上市板块"
        // }

      }
      return "全部";
    }

    $scope.showInfo = function () {

      Toolkit.alert('净值说明：</br>' +
        '【1】 如果是货币型基金，此列代表“每（百/万/百万）份基金已实现收益”；如果是创新型封闭式的分级子基金，此列代表“基金份额参考净值”</br>' +
        '【2】 如果是货币型基金，此列代表“7日年化收益率”；如果是创新型封闭式的分级子基金，此列代表“基金份额累计参考净值”</br>');
    }

    //视图进入后的事件，设置对应的分类对象代码和板块对象代码
    $scope.$on("$ionicView.afterEnter", function (event, data) {
      // handle event
      $rootScope.jumpFromHome = false;
    })

    //视图进入后的事件，设置对应的分类对象代码和板块对象代码
    $scope.$on("$ionicView.enter", function (event, data) {
      // handle event
      if (data.stateName == 'tab.stockList') {
        if (data.direction != "forward" && !$rootScope.jumpFromHome) {
          return;
        }

        $scope.data.isSupportCode = (["9577", "9578", "9579", "9580"].indexOf(data.stateParams.category) > -1)

        //清空接口方法
        $scope.methodList = null;
        $scope.methodDetail = null;
        if (data.stateParams.category == '9972') {
          // 债券预披露，大小公募
          $scope.category = Toolkit.getCategory(44);
        } else {
          $scope.category = Toolkit.getCategory(data.stateParams.category);
        }
        $scope.categoryMId = data.stateParams.categoryMId;
        $scope.baseChannelPath = data.stateParams.categoryMId;

        $scope.categoryName = $scope.getCategoryMName();


        $scope.board = Toolkit.getCategory(data.stateParams.board);//获取board

        $scope.boardCode = data.stateParams.boardCode;
        var path = $scope.categorySId || $scope.categoryMId || $scope.baseChannelPath || '';

        //新需求修复
        if (path == 1010) {
           $scope.board = Toolkit.getCategory("70");
           $scope.categorySId = data.stateParams.categorySId;
           // $scope.boardName = '预披露'
        }


        $scope.boardName = (['1015', '1016'].indexOf(path.toString().substring(0, 4)) > -1) ? "上市地" : "类别";
         if (path == 1011) {
           $scope.boardName = '上市板块';
        }
        // console.log($scope.boardName )
        $scope.methodList = data.stateParams.method;
        $scope.viewTitle = data.stateParams.title;
      }


      if ($scope.methodList) {
        $scope.annuArray = JSON.parse(window.localStorage.getItem($scope.methodList));

        //初始状态时，阻止下拉刷新
        $scope.hasMoreData = false;

        if ($scope.methodList == "getAnnuStockList") {
          $scope.codeList = Global.ProductCodes.stocks;
        } else if ($scope.methodList == "getAnnuFundList") {
          $scope.codeList = Global.ProductCodes.funds;
        } else if ($scope.methodList == "getAnnuBondList") {
          $scope.codeList = Global.ProductCodes.bonds;
        } else if ($scope.methodList == "getAnnuSharetransferList") {
          $scope.codeList = Global.ProductCodes.sharetransfer;
        } else {
          $scope.codeList = null;
        }
      }

      //向服务器请求刷新数据
      $scope.doRefresh();
    });


    //{{跳转到不同列表
    //公告列表
    $scope.goAnnuList = function (name) {
      switch (name) {
        case 'preipo':
          {
            $location.path('/tab/stockList/getAnnuPreList/9576/01/IPO公司/1010//');
            break;
          }
        case 'prebond':
          {
            $location.path('/tab/stockList/getAnnuPreList/9972/25/债券预披露公告/10151213//');
            break;
          }
        case 'stock':
          {
            $location.path('/tab/stockList/getAnnuStockList/9577/01/上市公司公告/1011//');
            break;
          }
        case 'neeq':
          {
            $location.path('/tab/stockList/getAnnuSharetransferList/9578/00/非上市公众公司公告/1012//');
            break;
          }
        case 'fund':
          {
            $location.path('/tab/stockList/getAnnuFundList/9579/00/基金公告/1013//');
            break;
          }
        case 'mutual':
          {
            $location.path('/tab/stockList/getAnnuFundMutualList/9580/00/互认基金公告/1014//');
            break;
          }
        case 'bond':
          {
            $location.path('/tab/stockList/getAnnuBondList/9581/25/债券公告/1015//');
            break;
          }
        // case 'abs':
        //   {
        //     $location.path('/tab/stockList/getAnnuAbsList/9582/04/资产支持证券公告/1016/');
        //     break;
        //   }
        default:
          {}
      }
    }


    //}}跳转到不同列表


    //{{分类代码处理



    /*...遗留板块bug...*/
    // $scope.setBoardcode=function (key) {
    //   $scope.categoryMId = '';
    //   $scope.categorySId = "";
    //   $scope.board1Name = "";
    //   $scope.boardName = "";
    //   $scope.boardCode = "";
    //   if ($scope.boardCode.toString() ==02){
    //     console.log("sajkdhja")
    //     $scope.board1Name == '深市板块';
    //     $scope.boardName == '深市板块'
    //   }
    //   $scope.doRefresh();
    //   $scope.closePopover();
    // }
    /*...遗留板块bug...*/


    $scope.clearCategory = function () {
      $scope.categoryMId = $scope.baseChannelPath;
      $scope.categorySId = "";
      $scope.categoryName = "全部";

      $scope.board1 = null;
      $scope.board1Name = "";
      $scope.board1Code = "";
      $scope.doRefresh();
      $scope.closePopover();
    }

    $scope.setMcategory = function (key, name) {
 // console.log(key)
      $scope.categoryName = name;
      $scope.categorySId = key;
      key = key + "";

      $scope.board1 = null;
      $scope.board1Name = "";
      $scope.board1Code = "";

      if (key.length <4) {
        $scope.setScategory($scope.categoryMId, name);
      } else {
        if ($scope.categorySId.toString().substring(0, 4) == 1010) {
          $scope.board = Toolkit.getCategory("70");
        } else if ($scope.categorySId.toString().substring(0, 4) == 1015) {
          $scope.board = Toolkit.getCategory("25");
          if (key == "1015121310") {
            // 大公募
            $scope.board = null;
          }
        }
        $scope.doRefresh();
        $scope.closePopover();
      }
    };


    $scope.setScategory = function (key, name) {

      $scope.categorySId = key;
      $scope.categoryMId = "";
      $scope.categoryName = name;

      $scope.board1 = null;
      $scope.board1Name = "";
      $scope.board1Code = "";

      if ($scope.categorySId.toString().substring(0, 4) == 1010) {
        $scope.board = Toolkit.getCategory("70");
      } else if ($scope.categorySId.toString().substring(0, 4) == 1015) {
        $scope.board = Toolkit.getCategory("25");
        if (key == "10151213") {
          $scope.board1 = Toolkit.getCategory(44);
          $scope.board1Name = "募集类型";
          $scope.board1Code = "";
        }
      } else if ($scope.categorySId.toString() == "101312") {
        $scope.boardName = "基金类别";
        $scope.board = Toolkit.getCategory("21");
      }

      $scope.doRefresh();
      $scope.closePopover();
    };

    $scope.setBoard = function (key, name) {
      $scope.boardCode = key;
      $scope.disclosureType = key;
      $scope.disclosureTypeName = name;
      $scope.boardName = name;
      if (!key) {
        var path = $scope.categorySId || $scope.categoryMId || $scope.baseChannelPath || '';
        $scope.boardName = (['1015', '1016'].indexOf(path.toString().substring(0, 4)) > -1) ? "上市地" : "全部";
        if ($scope.categorySId.toString() == "101312") {
          $scope.boardName = "基金类别";
        }
      }
      $scope.doRefresh();
      $scope.closePopover();
    };

    $scope.setBoard1 = function (key, name) {
      $scope.board1Code = key;
      $scope.disclosureType = key;
      $scope.board1Name = name;
      if (key == "1015121310") {
        $scope.board = null;
        $scope.boardCode = "";
        // $scope.boardName = "上市地";
      } else {
        $scope.board = Toolkit.getCategory("25");
      }
      $scope.doRefresh();
      $scope.closePopover();
    };

    $scope.goForward = function () {
      var selected = $ionicTabsDelegate.selectedIndex();
      if (selected != -1) {
        $ionicTabsDelegate.select(selected + 1);
      }
    }

    $scope.goBack = function () {
      $location.path("/tab/public")
        //$ionicHistory.goBack();
    }

    //{{日期处理
    $scope.timeType = 'start';

    var ipObj = {
      callback: function (val) { //Mandatory
        var var1 = val ? new Date(val).Format("yyyy-MM-dd") : "";
        if ($scope.timeType == 'start') {
          $scope.startDate = var1;
        } else if ($scope.timeType == 'end') {
          $scope.endDate = var1;
        }
        $scope.doRefresh();
      },
      titleLabel: null, //Optional
      todayLabel: '今天', //Optional
      closeLabel: '清除', //Optional
      setLabel: '确定', //Optional
      from: new Date(1949, 10, 1), //Optional
      to: new Date(), //Optional
      inputDate: new Date(), //Optional
      mondayFirst: true, //Optional
      closeOnSelect: true, //Optional
      dateFormat: 'yyyy-MM-dd', //Optional
      templateType: 'popup', //Optional
      modalHeaderColor: 'bar-positive',
      closeOnSelect: false, //Optional
      modalFooterColor: 'bar-positive' //Optional
    };

    $scope.openDatePicker = function (type) {
      $scope.timeType = type;
      if ($scope.timeType == 'start') {
        ipObj.inputDate = $scope.startDate ? new Date($scope.startDate) : new Date();
        ipObj.from = new Date(1949, 10, 1);
        ipObj.to = $scope.endDate ? new Date($scope.endDate) : new Date();
      } else {
        ipObj.inputDate = $scope.endDate ? new Date($scope.endDate) : new Date();
        ipObj.from = $scope.startDate ? new Date($scope.startDate) : new Date(1949, 10, 1);
        ipObj.to = new Date();
      }
      ionicDatePicker.openDatePicker(ipObj);
    };


    //}} 日期处理


    //--{{下拉代码条件框
    $scope.onChange = function (keyword) {
      if (!$scope.data.isSupportCode) {
        return
      }
      if (keyword.length > 0) {
        $scope.showCodeList = true;
        SearchSuggestService.query({ keyword: keyword, channelPath: $scope.baseChannelPath }).$promise.then(function (_response) {
          if (_response.status == 0) {
            $scope.filterCodeList = [];
            _response.data.forEach(function (v) {
              $scope.filterCodeList.push(v.code + ' ' + v.typeLabel + ' ' + v.name);

            });
          }
        });
      } else {
        $scope.showCodeList = false;
      }
    };

    $scope.setQueryCode = function (code) {
      if (code) {
        var index = code.indexOf(" ");
        $scope.queryCondition.keyword = code.substring(0, index);

      }
      $scope.closePopover();
      $scope.showCodeList = false;
    }

    $scope.search = function () {
      // if($scope.data.code == null){
      //   console.log("dahajk")
      //   $scope.data.isSupportCode  === '摩根'
      // }
      if ($scope.showCodeList){
        $scope.setQueryCode($scope.filterCodeList[0]);
      }

      $scope.showCodeList = false;
      $scope.doRefresh();
    }


    //--}} 下拉代码条件框


    //--{{过滤条件框
    $scope.popFilter = $ionicPopover.fromTemplateUrl('filter-popover.html', {
      scope: $scope
    });

    $ionicPopover.fromTemplateUrl('filter-popover.html', {
      scope: $scope
    }).then(function (popover) {
      $scope.popFilter = popover;
    });

    $scope.openFilterPopover = function ($event) {
      $scope.popFilter.show($event);
      //$scope.popover.show();
      // Toolkit.alert('点击pop');
    };

    $scope.closePopover = function () {
      $scope.showCodeList = false;
      $scope.popFilter.hide();
      $scope.popBoard.hide();
      $scope.popBoard1.hide();
    };
    // 清除浮动框
    $scope.$on('$destroy', function () {
      $scope.popFilter.remove();
      $scope.popBoard.remove();
      $scope.popBoard1.remove();
    });
    //--}}

    //--{{板块条件框

    $ionicPopover.fromTemplateUrl('board-popover.html', {
      scope: $scope
    }).then(function (popover) {
      $scope.popBoard = popover;
    });

    $scope.openBoardPopover = function ($event) {
      $scope.popBoard.show($event);
      //$scope.popover.show();
      // Toolkit.alert('点击pop');
    };

    $ionicPopover.fromTemplateUrl('board1-popover.html', {
      scope: $scope
    }).then(function (popover) {
      $scope.popBoard1 = popover;
    });

    $scope.openBoard1Popover = function ($event) {
      $scope.popBoard1.show($event);
    };

    //--}}
    $scope.doRefresh = function () {

      if ($scope.methodList) {
        $scope.pageNo = 1;
        $scope.getAnnuArray(false);
      }

      if ($scope.methodDetail) {
        $scope.getDetailData(false);
      }

    }


    $scope.loadMore = function () {
      // 上拉刷新
      if ($scope.methodList) {
        $scope.getAnnuArray(true);
      }
      //   $scope.$broadcast('scroll.infiniteScrollComplete');
    }




    // 新需求 IPO分类大版块
    $scope.upExtra = function() {
      // if (!$scope.extra) {
      //   return false;
      // }
      if ($scope.categoryMId == "1011" || $scope.categoryMId == "1012" || $scope.categoryMId == "1013" || $scope.categoryMId == "1014" || $scope.categoryMId == "1015") {
        return false;
      }
      return true;
    }







    $scope.getAnnuArray = function (isAppend) {
      var stocklist = null;

      if (!isAppend) {
        $ionicLoading.show();
        $scope.annuArray = [];
      }
      var promise = getAnnuService.query({
        method: $scope.methodList,
        keyword: $scope.queryCondition.keyword,
        boardCode: $scope.boardCode,
        disclosureType:$scope.disclosureType,
        typeCode: $scope.boardCode,

        categoryMId: $scope.categoryMId,
        categorySId: $scope.board1Code ? $scope.board1Code : $scope.categorySId,
        startDate: $scope.startDate,
        endDate: $scope.endDate,
        pageNo: $scope.pageNo,
        pageSize: $scope.pageSize,

      }).$promise;

      promise.then(function (_response) {
        if (!isAppend) {
          $ionicLoading.hide();
        }
        if (_response.status == "1") {
          if (isAppend) {
            $scope.annuArray = $scope.annuArray.concat(_response.list);
            $scope.annuArray.push($scope.disclosureTypeName)
            // console.log($scope.annuArray)
          } else {
            $scope.annuArray = _response.list;
            window.localStorage.setItem($scope.methodList, JSON.stringify($scope.annuArray));
          }
          //数据刷新成功后，如果数据不够10条，关闭上拉加载，防止反复触发加载
          $scope.hasMoreData = _response.list.length > 9;
          $scope.pageNo += 1;
        } else if (_response.status == "0") {
          if (isAppend) {
            $scope.hasMoreData = false;
          } else {
            $scope.annuArray = null;
            $scope.hasMoreData = false;
            $scope.listInfo = "没有符合条件的数据";
          }
        } else {
          Toolkit.alert('网络信号不好...');
          $scope.hasMoreData = false;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');
      }, function () {
        if (!isAppend) {
          $ionicLoading.hide();
        }
        Toolkit.alert('网络信号不好...');
        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');
        //数据刷新失败后，关闭上拉加载，防止反复触发加载
        $scope.hasMoreData = false;

      });
    };


    $scope.getDetailData = function () {
      var stocklist = null;
      $ionicLoading.show();
      var promise = getDetailService.query({
        method: $scope.methodDetail,
        keyword: $scope.queryCondition.keyword,
        boardCode: $scope.boardCode,
         disclosureType:$scope.disclosureType,
        code: $scope.detailCode,
        date: $scope.startDate,
      }).$promise;

      promise.then(function (_response) {
        $ionicLoading.hide();
        if (_response.status == "1") {
          $scope.detailData = _response.detail;
        } else {
          Toolkit.alert('网络信号不好...');
        }
      }, function () {
        $ionicLoading.hide();
        Toolkit.alert('网络信号不好...');
      });
    };

    $scope.getFileSize = function (url) {
      $http({
        method: 'HEAD',
        url: url
      }).then(function successCallback(response) {
        console.log(response);
        console.log(response.headers('content-length'));

        // this callback will be called asynchronously
        // when the response is available
      }, function errorCallback(response) {
        console.log(response);
        // called asynchronously if an error occurs
        // or server returns response with an error status.
      });
    }

    $scope.openInExternalBrowser = function (url, type, name, date) {
      if (type == "txt"
          && !url.endsWith(".pdf")
          && !url.endsWith(".doc")
          && !url.endsWith(".docx")
          && !url.endsWith(".xls")
          && !url.endsWith(".xlsx")) {
        var fullUrl = Global.HOST + "/Disclosure/openHtml.do?name=" + name + "&date=" + date + "&path=" + url;

        window.open(fullUrl, '_system');
      } else if (type == "xbrl") {
        var fullUrl = Global.XBRLHOST + url;
        window.open(fullUrl, '_system');
      } else {
        var fullUrl = url;
        if (url.indexOf("http://") < 0) {
          var fullUrl = Global.WEB + url;
        }

        Toolkit.openFile(fullUrl);
      }
    };
  })
