/**
 * Created by zhujunchao on 16/5/11.
 */
angular.module('public.services', [])
  .factory('getAnnuService', function($resource) {
    return $resource(Global.HOST + '/Disclosure/:method' + '.do?' +
      'keyword=:keyword' +
      '&boardCode=:boardCode' +
      '&disclosureType=:disclosureType'+
      '&transferType=:typeCode' +
      '&typeCode=:typeCode' +
      '&classCode=:classCode' +
      '&categoryMId=:categoryMId' +
      '&categorySId=:categorySId' +
      '&operationType=:boardCode' +
      '&shortName=:boardCode' +
      '&organType=:boardCode' +
      '&fundType=:typeCode' +
      '&startDate=:startDate' +
      '&endDate=:endDate' +
      '&pageNo=:pageNo' +
      '&pageSize=:pageSize', {
        method: '@method',
        keyword: '@keyword',
        boardCode: '@boardCode',
        disclosureType:'@disclosureType',
        classCode: '@classCode',
        typeCode: '@extraCode',
        categoryMId: '@categoryMId',
        categorySId: '@categorySId',
        startDate: '@startDate',
        endDate: '@endDate',
        pageNo: '@pageNo',
        pageSize: '@pageSize'
      }, {
        query: {
          method: 'POST',
          isArray: false,
          header: {
            'Access-Control-Allow-Origin': "*"
          }
        }
      });
  })
  .factory('getDetailService', function($resource) {
    return $resource(Global.HOST + '/Disclosure/:method' + '.do?' +
      'keyword=:keyword' +
      '&boardCode=:boardCode' +
      '&disclosureType=:disclosureType'+
      '&code=:code' +
      '&categoryMId=:categoryMId' +
      '&startDate=:startDate' +
      '&userId=:userId', {
        userId: '@userId',
        method: '@method',
        keyword: '@keyword',
        boardCode: '@boardCode',
        disclosureType:'@disclosureType',
        code: '@code',
        startDate: '@startDate',
        categoryMId: '@categoryMId'
      }, {
        query: {
          method: 'POST',
          isArray: false,
          header: {
            'Access-Control-Allow-Origin': "*"
          }
        }
      });
  })
  .factory('Login', function($resource) {
    return $resource(Global.HOST + '/Disclosure/getUserLogin.do?' +
      'username=:username' +
      '&tPassword=:tPassword', {
        username: '@username',
        tPassword: '@tPassword'
      }, {
        get: {
          method: 'POST',
          isArray: false,
          header: {
            'Access-Control-Allow-Origin': "*"
          }
        }
      });
  })
  .factory('Register', function($resource) {
    return $resource(Global.HOST + '/Disclosure/getUserRegister.do?' +
      'username=:username' +
      '&password=:password',
      '&email=:mobile',
      '&valiCode=:valiCode', {
        username: '@username',
        password: '@password',
        mobile: '@mobile',
        valiCode: '@valiCode'
      }, {
        get: {
          method: 'POST',
          isArray: false,
          header: {
            'Access-Control-Allow-Origin': "*"
          }
        }
      });
  })
  .factory('MyFavoriteList', function($resource) {
    return $resource(Global.HOST + '/Disclosure/getUserOptionalList.do?' +
      'userId=:userId' +
      '&tPassword=:tPassword' +
      '&type=:type', {
        userId: '@userId',
        tPassword: '@tPassword',
        type: '@type'
      }, {
        query: {
          method: 'POST',
          isArray: false,
          header: {
            'Access-Control-Allow-Origin': "*"
          }
        }
      });
  })
  .factory('MyMessageList', function($resource) {
    return $resource(Global.HOST + '/Disclosure/getNoticeList.do?pageNo=1&pageSize=100', {
      userId: '@userId',
      tPassword: '@tPassword'
    }, {
      query: {
        method: 'POST',
        isArray: false,
        header: {
          'Access-Control-Allow-Origin': "*"
        }
      }
    });
  })
  .factory('AddFavorite', function($resource) {
    return $resource(Global.HOST + '/Disclosure/getUserOptionalChange.do?' +
      'userId=:userId' +
      '&tPassword=:tPassword' +
      '&optionalId=:optionalId' +
      '&type=:type' +
      '&tag=:tag', {
        userId: '@userId',
        tPassword: '@tPassword',
        optionalId: '@optionalId',
        type: '@type',
        tag: '@tag'

      }, {
        set: {
          method: 'POST',
          isArray: false,
          header: {
            'Access-Control-Allow-Origin': "*"
          }
        }
      });
  })
  .factory('FullSearch', function($resource) {
    return $resource(Global.SEARCH_HOST + '/searchApp.html?' +
      'fullKeyWordInput=:fullKeyWordInput' +
      '&fullSearchTypeInput=:fullSearchTypeInput' +
      '&fullTimeOrderInput=:fullTimeOrderInput' +
      '&fullTimeRangeInput=:fullTimeRangeInput', {
        fullKeyWordInput: '@fullKeyWordInput',
        fullSearchTypeInput: '@fullSearchTypeInput',
        fullTimeOrderInput: '@fullTimeOrderInput',
        fullTimeRangeInput: '@fullTimeRangeInput'
      }, {
        query: {
          method: 'GET',
          isArray: false
        }
      });
  })
  .factory('Toolkit', function($ionicPopup, $ionicLoading, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $http) {
    return {
      alert: function(msg) {
        $ionicPopup.alert({
          title: '提示',
          template: msg
        });
      },
      toDecimal2: function(x) {
        return d3.format(',')(parseFloat(d3.format('.2f')(x)));
      },
      getCategory: function(code) {
        var result = new Array();
        if (Global.CategoryDic) {
          for (var i = 0; i < Global.CategoryDic.length; i++) {
            if (code == Global.CategoryDic[i].code) {
              return Global.CategoryDic[i].mains;
            }
          }
        }
        return null;
      },
      getCategoryByKey: function(key) {
        if (Global.CategoryDic) {
          for (var i = 0; i < Global.CategoryDic.length; i++) {
            if (key == Global.CategoryDic[i].key) {
              return Global.CategoryDic[i];
            } else if (key && key.indexOf(Global.CategoryDic[i].key) == 0) {
              for (var j = 0; j < Global.CategoryDic[i].mains.length; j++) {
                if (key == Global.CategoryDic[i].mains[j].key) {
                  return Global.CategoryDic[i].mains[j];
                }
              }
            }
          }
        }
        return null;
      },
      trustHtml: function(data) {
        return $sce.trustAsHtml(data);
      },
      openURL: function(url) {
        $ionicLoading.show();
        // 兼容含中文的URL
        url = encodeURI(url);
        try {
          handleDocumentWithURL(function() {
            $ionicLoading.hide();
          }, function(error) {
            $ionicLoading.hide();
            if (error == 53) {
              this.alert('没找到可以打开文件的APP');
            }
            console.log('open:', url, 'error:', error);
          }, url);
        } catch (err) {
          console.log(err);
          $ionicLoading.hide();
        }

      },
      openFile: function(url) {
        if (ionic.Platform.platform() == "win32") {
          window.open(url, '_system');
          return;
        }

        var li = url.length - 6;

        // if ((url.endsWith('doc') || url.endsWith('docx'))
        //   && ionic.Platform.isIOS()) {
        //   $ionicPopup.alert({
        //     title: '提示',
        //     template: '文件格式暂不支持，无法打开'
        //   });
        //   return
        // }

        if (url.indexOf('pdf', li) < 0 &&
          url.indexOf('doc', li) < 0 &&
          url.indexOf('docx', li) < 0 &&
          url.indexOf('xls', li) < 0 &&
          url.indexOf('xlsx', li) < 0) {
          window.open(url, '_system');
          return;
        }
        var that = this;
        $http({
          method: 'HEAD',
          url: url
        }).then(
          function successCallback(response) {
            var len = response.headers('content-length');
            var M = 1024 * 1024;
            if (len > M) {
              var confirmPopup = $ionicPopup.confirm({
                title: '提示',
                template: '文件大小' + Math.round((len / M) * 100) / 100 + 'M是否下载？',
                cancelText: '取消',
                okText: '下载'
              });

              confirmPopup.then(function(res) {
                if (!res) {
                  return;
                } else {
                  that.openURL(url);
                }
              });
            } else {
              that.openURL(url);
            }
          },
          function errorCallback(response) {
            that.alert('文件存在问题，无法下载');
          });
      },
      downloadFile: function(url) {
        document.addEventListener('deviceready', function() {
          var confirmPopup = $ionicPopup.confirm({
            title: '提示',
            template: '是否下载', //从服务端获取更新的内容
            cancelText: '取消',
            okText: '确定'
          });
          var filename = url.slice(-1, -44);
          confirmPopup.then(function(res) {
            if (!res) {
              return;
            }

            $ionicLoading.show({
              template: "已经下载：0%"
            });

            var targetPath = "file:///storage/sdcard0/Download/" + filename; //APP下载存放的路径，可以使用cordova file插件进行相关配置
            var trustHosts = true
            var options = {};
            var ft = new FileTransfer();
            $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function(result) {
              // 打开下载下来的APP
              $cordovaFileOpener2.open(targetPath, 'application/pdf').then(function() {
                // 成功
              }, function(err) {
                // 错误
              });
              $ionicLoading.hide();
            }, function(err) {
              alert('下载失败');
            }, function(progress) {
              //进度，这里使用文字显示下载百分比
              $timeout(function() {
                var downloadProgress = (progress.loaded / progress.total) * 100;
                $ionicLoading.show({
                  template: "已经下载：" + Math.floor(downloadProgress) + "%"
                });
                if (downloadProgress > 99) {
                  $ionicLoading.hide();
                }
              })
            });
          });
        });
      }
    };
  })
