/**
 * Created by zhujunchao on 16/5/8.
 */
angular.module('starter.regular', ['ionic',
  'ngCordova',
  'ngResource',
  'public.services',
  "integralui"
])

.controller('RegularCtrl', function ($scope, $rootScope,
  $ionicTabsDelegate,
  $location,
  $ionicPopup,
  $stateParams,
  $ionicPopover,
  $sce, $ionicLoading, $ionicHistory,
  ionicDatePicker,

  getAnnuService,
  getDetailService,
  getAnnuCategoryService,
  Toolkit,
  AddFavorite
) {

  $scope.queryCondition = {
    keyword: "",
  };


  $scope.keyword = "";
  $scope.boardCode = "";
  $scope.categoryMId = "";
  $scope.categorySId = "";
  $scope.startDate = "";
  $scope.endDate = "";
  $scope.pageNo = 1;
  $scope.pageSize = 20;

  $scope.methodList = null;
  $scope.annuArray = null;

  $scope.methodDetail = null;
  $scope.detailData = null;
  $scope.isFavorite = false;

  //$rootScope.categoryDic=null;
  $scope.category = null;
  $scope.categoryName = "全部";

  $scope.board = null;
  $scope.boardName = "板块";
  $scope.PlatformIsIOS = ionic.Platform.isIOS();
  $scope.listInfo = "正在加载...";
  //--------------------------------------------------------------------------下方是不同view的分别处理-------------------------------------------------------------------------

  //视图进入后的事件，设置对应的分类对象代码和板块对象代码
  // $scope.$on("$ionicView.enter", function (event, data) {
    //   switch (data.stateName) { //公告相关
    //     //产品列表
    //     case 'tab.regularList':
    //       {
    //         if (data.direction != "forward" && !$rootScope.jumpFromHome) {
    //           return;
    //         }
    //         //清空接口方法
    //         $scope.methodList = null;
    //         $scope.methodDetail = null;
    //         $scope.category = Toolkit.getCategory(data.stateParams.category);
    //         $scope.categoryMId = data.stateParams.categoryMId;
    //         $scope.categoryName = $scope.getCategoryMName();
    //         $scope.board = Toolkit.getCategory(data.stateParams.board);
    //         $scope.methodList = data.stateParams.method;
    //         $scope.viewTitle = data.stateParams.title;
    //         break;
    //       }
    //
    //       //产品详情
    //     case 'regularDetail':
    //       { //清空接口方法
    //         $scope.methodList = null;
    //         $scope.methodDetail = null;
    //         $scope.methodDetail = data.stateParams.methodDetail;
    //         $scope.detailCode = data.stateParams.code;
    //         $scope.categoryMId = data.stateParams.categoryMId;
    //         break;
    //       }
    //   }
    //   if ($scope.methodList) {
    //     //初始状态时，阻止下拉刷新
    //     $scope.hasMoreData = false;
    //   }
    //   //向服务器请求刷新数据
    //   $scope.doRefresh();
    // });




  //视图进入后的事件，设置对应的分类对象代码和板块对象代码
  $scope.$on("$ionicView.enter", function (event, data) {
    switch (data.stateName) { //公告相关
      //产品列表
      case 'tab.regularList':
      {
        if (data.direction != "forward" && !$rootScope.jumpFromHome) {
          return;
        }
        //清空接口方法
        $scope.methodList = null;
        $scope.methodDetail = null;
        $scope.category = Toolkit.getCategory(data.stateParams.category);
        $scope.categoryMId = data.stateParams.categoryMId;
        $scope.categoryName = $scope.getCategoryMName();

        $scope.methodList = data.stateParams.method;
        $scope.viewTitle = data.stateParams.title;


        if (data.stateParams.categoryMId == 401110) {
          $scope.board = Toolkit.getCategory('41');
          $scope.boardName = "全部"
          $scope.boardCode = '';
          $scope.categorySId = '40111011';
        } else if (data.stateParams.categoryMId == 401111) {
          $scope.board = Toolkit.getCategory('42');
          $scope.boardName = "板块类型"
          $scope.boardCode = '';
          $scope.categorySId = '40111111';
        }else {
          $scope.board = Toolkit.getCategory(data.stateParams.board);
        }

        break;
      }

      //产品详情
      case 'regularDetail':
      { //清空接口方法
        $scope.methodList = null;
        $scope.methodDetail = null;
        $scope.methodDetail = data.stateParams.methodDetail;
        $scope.detailCode = data.stateParams.code;
        $scope.categoryMId = data.stateParams.categoryMId;
        break;
      }
    }
    if ($scope.methodList) {
      //初始状态时，阻止下拉刷新
      $scope.hasMoreData = false;
    }
    //向服务器请求刷新数据
    $scope.doRefresh();
  });

  $scope.trustHtml = function (data) {
    return $sce.trustAsHtml(data);
  }

  $scope.getCategoryMName = function () {
    if (!$scope.category) {
      return null;
    }

    for (var i = 0; i < $scope.category.length; i++) {
      if ($scope.categoryMId == $scope.category[i].key) {
        if ($scope.categoryMId == '401110' || $scope.categoryMId == '401111' || $scope.categoryMId === '401112' || $scope.categoryMId == '401113' || $scope.categoryMId == '401114') {
          return $scope.category[i].subs[0].value;
        }
        return $scope.category[i].value;
      }
    }
    return "全部";
  }

  //{{跳转到不同列表

  $scope.goRegularList = function (name, categoryMid) {
    switch (name) {
      case 'xz':
        {
          $location.path('/tab/regularList/getRegularAdminList/9599/01/行政监管信息/' + categoryMid);
          break;
        }
      case 'zl':
        {
          $location.path('/tab/regularList/getRegularDiskList/9600/01/自律监管信息/' + categoryMid);
          break;
        }
      case 'zj':
        {
          $location.path('/tab/regularList/getRegularFirmList/9592/01/中介机构/' + categoryMid);
          break;
        }
      default:
        {}
    }
  }

  //产品详情
  $scope.goDetail = function (code, filePath) {
    $scope.detailCode = code;
    if (filePath) {
      $scope.openInExternalBrowser(filePath);
      return;
    }
    switch ($scope.methodList) {
      case 'getRegularAdminList':
        {
          $location.path('/regularDetail/' + $scope.detailCode + "/getRegularAdminDetail/" + $scope.categoryMId);
          break;
        }
      case 'getRegularDiskList':
        {
          $location.path('/regularDetail/' + $scope.detailCode + "/getRegularDiskDetail/" + $scope.categoryMId);
          break;
        }
      case 'getRegularFirmList':
        {
          $location.path('/regularDetail/' + $scope.detailCode + "/getRegularFirmDetail/" + $scope.categoryMId);
          break;
        }
      default:
        {}
    }
  }


  //}}跳转到不同列表

  //--------------------------------------------------------------------------下方是通用部分函数-------------------------------------------------------------------------


  $scope.showAlert = function (msg) {
    var alertPopup = $ionicPopup.alert({
      title: '提示',
      template: msg
    });
  }

  $scope.formatDate = function (time) {
    return moment(time).format('YYYY-MM-DD');
  }

  //{{分类代码处理
  $scope.clearCategory = function () {
    $scope.categoryMId = "";
    $scope.categorySId = "";
    $scope.categoryName = "全部";
    $scope.doRefresh();
    $scope.closePopover();
  }

  $scope.setMcategory = function (key, name) {
    if (key == '401110' || key == '401111' || key == '401112' || key == '401113' || key == '401114') {
      return;
    }
    $scope.categoryMId = key;
    $scope.categoryName = name;
    $scope.doRefresh();
    $scope.closePopover();
  };

  $scope.getKeywordPlaceholder = function () {
    switch ($scope.categorySId.toString()) {
      case '40111011':
      case '40111111':
        return '代码/简称/涉及对象';
      default:
        return '关键字';
    }
  }

  $scope.setScategory = function (key, name) {
    $scope.categorySId = key;
    $scope.categoryName = name;
    if (key == 40111012) {
      $scope.board = Toolkit.getCategory('35');
      $scope.boardName = "公告类型"
      $scope.boardCode = '';
    } else if (key == 40111011) {
      $scope.board = Toolkit.getCategory('41');
      $scope.boardName = "监管类型"
      $scope.boardCode = '';
    } else if (key == 40111111) {
      $scope.board = Toolkit.getCategory('42');
      $scope.boardName = "板块类型"
      $scope.boardCode = '';
    } else {
      $scope.board = null;
      $scope.boardName = ""
      $scope.boardCode = '';
    }
    $scope.doRefresh();
    $scope.closePopover();
  };


  $scope.setBoard = function (key, name) {
    $scope.boardCode = key;
    $scope.boardName = name;
    if (!key) {
      if ($scope.categorySId == 40111012) {
        $scope.boardName = "公告类型"
      } else if ($scope.categorySId == 40111011) {
        $scope.boardName = "监管类型"
      } else if ($scope.categorySId == 40111111) {
        $scope.boardName = "板块类型"
      }
    }
    $scope.doRefresh();
    $scope.closePopover();
  };

  //}}
  //{{日期处理

  $scope.timeType = 'start';

  var ipObj = {

    callback: function (val) { //Mandatory
      console.log('Return value from the datepicker popup is : ' + val, new Date(val));
      var var1 = val ? new Date(val).Format("yyyy-MM-dd") : '';
      if ($scope.timeType == 'start') {
        $scope.startDate = var1;
      } else if ($scope.timeType == 'end') {
        $scope.endDate = var1;
      }
      $scope.doRefresh();
    },

    titleLabel: 'Title', //Optional
    todayLabel: '今天', //Optional
    closeLabel: '清除', //Optional
    setLabel: '确定', //Optional
    from: new Date(2011, 3, 1), //Optional
    to: new Date(), //Optional
    inputDate: new Date(), //Optional
    mondayFirst: true, //Optional
    closeOnSelect: true, //Optional
    dateFormat: 'yyyy-MM-dd', //Optional
    templateType: 'popup', //Optional
    modalHeaderColor: 'bar-positive',
    closeOnSelect: false, //Optional
    modalFooterColor: 'bar-positive' //Optional
  };

  $scope.openDatePicker = function (type) {
    console.log(type);
    $scope.timeType = type;

    if ($scope.timeType == 'start') {
      ipObj.inputDate = $scope.startDate ? new Date($scope.startDate) : new Date();
      ipObj.from = new Date(2011, 3, 1);
      ipObj.to = $scope.endDate ? new Date($scope.endDate) : new Date();
    } else {
      ipObj.inputDate = $scope.endDate ? new Date($scope.endDate) : new Date();
      ipObj.from = $scope.startDate ? new Date($scope.startDate) : new Date(2011, 3, 1);
      ipObj.to = new Date();
    }
    ionicDatePicker.openDatePicker(ipObj);
  };

  //}} 日期处理


  //--{{过滤条件框
  $scope.popFilter = $ionicPopover.fromTemplateUrl('filter-popover.html', {
    scope: $scope
  });

  $ionicPopover.fromTemplateUrl('filter-popover.html', {
    scope: $scope
  }).then(function (popover) {
    $scope.popFilter = popover;
  });

  $scope.openFilterPopover = function ($event) {
    $scope.popFilter.show($event);
    //$scope.popover.show();
    // $scope.showAlert('点击pop');
  };

  $scope.closePopover = function () {
    $scope.popFilter.hide();
    $scope.popBoard.hide();
  };
  // 清除浮动框
  $scope.$on('$destroy', function () {
    $scope.popFilter.remove();
    $scope.popBoard.remove();
    //todo:other popover remore
  });
  //--}}

  //--{{板块条件框

  $ionicPopover.fromTemplateUrl('board-popover.html', {
    scope: $scope
  }).then(function (popover) {
    $scope.popBoard = popover;
  });

  $scope.openBoardPopover = function ($event) {
    $scope.popBoard.show($event);
    //$scope.popover.show();
    // $scope.showAlert('点击pop');
  };

  //--}}

  $ionicPopover.fromTemplateUrl('board-popover.html', {
    scope: $scope
  }).then(function (popover) {
    $scope.popBoard = popover;
  });

  $scope.openBoardPopover = function ($event) {
    $scope.popBoard.show($event);
    //$scope.popover.show();
    // $scope.showAlert('点击pop');
  };

  $scope.doRefresh = function () {

    if ($scope.methodList) {
      $scope.pageNo = 1;
      $scope.getAnnuArray(false);
    }

    if ($scope.methodDetail) {
      $scope.getDetailData(false);
    }

  }

  $scope.goBack = function () {
    if ($scope.methodDetail == null) {
      $location.path("/tab/regulatory")
    } else {
      $ionicHistory.goBack();
    }
  }

  $scope.loadMore = function () {
    // 上拉刷新
    if ($scope.methodList) {
      $scope.getAnnuArray(true);
    }
    //   $scope.$broadcast('scroll.infiniteScrollComplete');
  }

  $scope.search = function () {
    $scope.doRefresh();
  }

  $scope.getAnnuArray = function (isAppend) {
    var stocklist = null;
    var promise = getAnnuService.query({
      method: $scope.methodList,
      keyword: $scope.queryCondition.keyword,
      boardCode: $scope.boardCode,
      typeCode: $scope.boardCode,
      categoryMId: $scope.categoryMId,
      categorySId: $scope.categorySId,
      startDate: $scope.startDate,
      endDate: $scope.endDate,
      pageNo: $scope.pageNo,
      pageSize: $scope.pageSize,
    }).$promise;

    if (!isAppend) {
      $ionicLoading.show();
    }
    promise.then(function (_response) {
      if (!isAppend) {
        $ionicLoading.hide();
      }
      if (_response.status == "1") {
        if (isAppend) {
          $scope.annuArray = $scope.annuArray.concat(_response.list);
        } else {
          $scope.annuArray = _response.list;
        }
        if (_response.date)
          $scope.startDate = _response.date;
        //数据刷新成功后，如果数据不够10条，关闭上拉加载，防止反复触发加载
        $scope.hasMoreData = _response.list.length > 9;
        $scope.pageNo += 1;
      } else if (_response.status == "0") {
        if (isAppend) {
          $scope.hasMoreData = false;
        } else {
          $scope.annuArray = null;
          $scope.hasMoreData = false;
          $scope.listInfo = "没有符合条件的数据";
        }
      } else {
        Toolkit.alert('网络信号不好...');
        $scope.hasMoreData = false;
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.$broadcast('scroll.refreshComplete');
    }, function () {
      if (!isAppend) {
        $ionicLoading.hide();
      }
      Toolkit.alert('网络信号不好...');
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.$broadcast('scroll.refreshComplete');
      //数据刷新失败后，关闭上拉加载，防止反复触发加载
      $scope.hasMoreData = false;
    });
  };

  $scope.getDetailData = function () {
    var stocklist = null;
    var promise = getDetailService.query({
      method: $scope.methodDetail,
      code: $scope.detailCode,
      categoryMId: $scope.categoryMId,
    }).$promise;
    $ionicLoading.show();
    promise.then(function (_response) {

      $ionicLoading.hide();

      if (_response.status == "1") {
        $scope.detailData = _response.detail;
        $scope.detailName = _response.name;

        var cleaner = new DOMCleaner(_response.detail.data.content);
        var html = cleaner.clean();
        // var html = dom.html();
        $scope.detailData.data.content = html.trim() ? html : '';
      } else {
        $scope.showAlert('网络信号不好...');
      }
    }, function () {
      $ionicLoading.hide();
      $scope.showAlert('网络信号不好...');
    });
  };

  $scope.doFavorite = function () {
    var type = '01';
    if ($scope.methodDetail == 'getProdStockDetail') {
      type = '01';
    } else if ($scope.methodDetail == 'getProdFundDetail') {
      type = '02';
    }
    var tag = '01';
    if (!$scope.isFavorite) {
      tag = '02';
    }

    var promise = AddFavorite.set({
      userId: Global.User.userId,
      mPassword: Global.User.mPassword,
      optionalId: $scope.detailData.id,
      type: type,
      tag: tag
    }).$promise;
    promise.then(function (_response) {
      if (_response.status == "1") {
        $scope.isFavorite = !$scope.isFavorite;

      } else if (_response.status == "0") {
        $scope.showAlert('操作自选失败(:');
      } else {
        $scope.showAlert('用户名或密码错误 (:');

      }
    }, function () {
      Toolkit.alert('网络信号不好(:');
    });
  }


  $scope.openInExternalBrowser = function (url) {
    var fullUrl = url;
    if (url.indexOf("http://") < 0) {
      var fullUrl = Global.WEB + url;
    }
    Toolkit.openFile(fullUrl);
  };

})
