// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
var appVersion = "0.0.5";
var Global = {
  // Browser.DEV
  // "HOST": "/server",
  // "SEARCH_HOST": "/search",
  // "WEB": "http://localhost:8080",
  // "XBRLHOST": "http://xbrl.seid.org.cn/REPORT/",

  // APP.DEV
  // "HOST": "http://192.168.1.4:9090",
  // "SEARCH_HOST": "http://www.seid.org.cn",
  // "WEB": "http://www.seid.org.cn",
  // "XBRLHOST": "http://xbrl.seid.org.cn/REPORT/",

  // APP.Test
  //
  // "HOST": "http://192.169.7.13:8090",
  // "SEARCH_HOST": "http://192.169.7.31:8081",
  // "WEB": "http://192.169.7.31:8081",
  // "XBRLHOST": "http://xbrl.seid.com.cn/REPORT/",



  // APP.Prod
  "HOST": "https://www.seid.org.cn",
  "SEARCH_HOST": "https://www.seid.org.cn",
  "WEB": "https://www.seid.org.cn",
  "XBRLHOST": "http://xbrl.seid.com.cn/REPORT/",

  "CategoryDic": null,
  "User": null,
  "Password": null,
  "ProductCodes": null
};

Date.prototype.Format = function (fmt) {
  var o = {
    "M+": this.getMonth() + 1, //月份
    "d+": this.getDate(), //日
    "h+": this.getHours(), //小时
    "m+": this.getMinutes(), //分
    "s+": this.getSeconds(), //秒
    "q+": Math.floor((this.getMonth() + 3) / 3), //季度
    "S": this.getMilliseconds() //毫秒
  };
  if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
  for (var k in o) {
    if (new RegExp("(" + k + ")").test(fmt)) {
      fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    }
  }

  return fmt;
}

angular.module('starter', [
  'ionic',
  'starter.controllers',
  'starter.services',
  'ionic-datepicker',
  'ngCordova',
  'starter.public',
  'starter.products',
  'starter.markets',
  'starter.regular',
  'starter.home',
  'starter.search',
  'starter.me',
  'home.services',
  'public.services',
  'products.services',
  'me.services'
])
  .run([
    '$window',
    '$timeout',
    '$ionicPlatform',
    '$rootScope',
    '$ionicActionSheet',
    '$cordovaAppVersion',
    '$ionicPopup',
    '$ionicLoading',
    '$cordovaFileTransfer',
    '$cordovaFile',
    '$cordovaFileOpener2',
    '$http',
    function ($window,$timeout,$ionicPlatform, $rootScope, $ionicActionSheet, $cordovaAppVersion,
              $ionicPopup, $ionicLoading, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $http) {
      $ionicPlatform.ready(function ($rootScope) {
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          cordova.plugins.Keyboard.disableScroll(true);
        }
        if (window.StatusBar) {
          // org.apache.cordova.statusbar required
          StatusBar.styleDefault();


        }

        // if (window.cordova) {
        //   cordova.getAppVersion(function (version) {
        //     console.log(version)
        //     appVersion = version;
            //alert(version); //0.0.1
        //   })
        // }

        // $rootScope.deviceInformation = ionic.Platform.device();
        // $scope.currentPlatform = ionic.Platform.platform();
        // $scope.currentPlatformVersion = ionic.Platform.version();
        // $scope.getDeviceInfo = function () {
        //   alert($rootScope.deviceInformation.uuid);
        // }

        // if (window.cordova) {
          if (ionic.Platform.isAndroid()) {
            checkUpdateAndroid();
          }
           if (ionic.Platform.isIOS()){
             checkUpdateIOS();
           }

      });

      // 检查更新
      function checkUpdateAndroid() {
        $http({
          method: 'GET',
          url: Global.HOST+'/Disclosure/version/version.json',
          // url:'http://192.169.7.13:8090/version.json',
          header: {
            'Access-Control-Allow-Origin': "*"
          }
        }).then(function (data) {
          // console.log(data)
          var serverVersion = data.data.version[0].value;
          var version = '0.0.5';
          var type = navigator.connection.type;


          // var nowVersionNum = parseInt(version.toString().replace(new RegExp(/(\.)/g), '0'));
          // console.log(nowVersionNum)
          // var newVersionNum = parseInt(serverVersion.toString().replace(new RegExp(/(\.)/g), '0'))
          // console.log(newVersionNum)

          var nowVersionNum = version.split('.');
          var newVersionNum = serverVersion.split('.');
          console.log(nowVersionNum)
          console.log(newVersionNum)

          var minL = Math.min(nowVersionNum.length,newVersionNum.length);//将版本号拆分成数字
          console.log(minL)

          var pos = 0;//当前比较位
          var diff = 0;//当前位比较是否相等

          //每个比较如果当前位相等则比较下一位
          while (pos < minL){
            diff = parseInt(nowVersionNum[pos]) - parseInt(newVersionNum[pos]);
            console.log(diff)
            if (diff!=0){
              break;
            }
            pos++;
          }

          if (diff < 0) {
              var myPopup = $ionicPopup.confirm({
                title: '版本更新',
                template: '<div style="text-align: center">发现新版本,请到应用市场下载更新</div>',
                cancelText: '稍后再试',
                okText: '立即更新'
                // buttons:[
                //   {text:'确认',
                //   type: 'button-positive'}
                // ]
              });
              myPopup.then(function (res) {
                if (res) {
                  //如果是安卓平台,直接下载apk安装升级
                  if (ionic.Platform.isAndroid()) {
                    UpdateForAndroid();
                    return;
                  }

                } else {
                  //取消更新
                }
              });

          }
        })
      };
      function checkUpdateIOS() {

        $http({
          method: 'GET',
          url: Global.HOST+'/Disclosure/version/version.json',
          // url:'http://192.169.7.13:8090/version.json',
          header: {
            'Access-Control-Allow-Origin': "*"
          }
        }).then(function (data) {
          var serverVersion = data.data.version[0].value;
          console.log(serverVersion)
          // var serverVersion = '0.0.3';

          var version = '0.0.5';
          var nowVersionNum = version.split('.');
          var newVersionNum = serverVersion.split('.');
          console.log(nowVersionNum)
          console.log(newVersionNum)

          var minL = Math.min(nowVersionNum.length,newVersionNum.length);//将版本号拆分成数字
          console.log(minL)

          var pos = 0;//当前比较位
          var diff = 0;//当前位比较是否相等

          //每个比较如果当前位相等则比较下一位
          while (pos < minL){
            diff = parseInt(nowVersionNum[pos]) - parseInt(newVersionNum[pos]);
            console.log(diff)
            if (diff!=0){
              break;
            }
            pos++;
          }
          if (diff<0){
            console.log('新版本')
            var myPopup=$ionicPopup.confirm({
              title: '提示',
              template: '发现新版本，请到<span style="color: #387ef5;font-size: 18px">AppStore</span>中下载',
              cancelText: '取消',
              okText: '确认'

              // okText:'确认',
              // type: 'button-positive',
              // template:'发现新版本，请到<span style="color: #387ef5;font-size: 18px">appStore</span>中下载'
            });
            myPopup.then(function (res) {
              if (res) {

                if (ionic.Platform.isIOS()){
                  UpdateForIOS();
                  return
                }
              } else {
                //取消更新
              }
            });
          }else if(diff==0){
            console.log('稳定版')
          }


        }).catch(function(res){
          // console.log(res)
        })
      };

      //iOS版实现更新升级需要跳转到苹果商店进行
      function UpdateForIOS(){
        console.log('https://itunes.apple.com/cn/app/%E4%B8%AD%E8%AF%81e%E6%8A%AB%E9%9C%B2/id1230079642?mt=8');
        $window.open('https://itunes.apple.com/cn/app/%E4%B8%AD%E8%AF%81e%E6%8A%AB%E9%9C%B2/id1230079642?mt=8');//跳转到APP商店，这样即可
      }

       function UpdateForAndroid(){
         console.log(' https://a.app.qq.com/o/simple.jsp?pkgname=com.zze.publish');
         $window.open(' https://a.app.qq.com/o/simple.jsp?pkgname=com.zze.publish');//跳转到APP商店，这样即可
       }
    }
  ])
  .config(function (ionicDatePickerProvider) {
    var datePickerObj = {
      inputDate: new Date(),
      setLabel: 'Set',
      todayLabel: 'Today',
      closeLabel: 'Close',
      mondayFirst: false,
      weeksList: ["日", "一", "二", "三", "四", "五", "六"],
      monthsList: ["1月", "2月", "3月", "4月", "5月", "6月", "7月", "8月", "9月", "10月", "11月", "12月"],
      templateType: 'popup',
      showTodayButton: true,
      closeOnSelect: false
    };
    ionicDatePickerProvider.configDatePicker(datePickerObj);
  })
  .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $locationProvider, $cordovaInAppBrowserProvider) {
    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

    $ionicConfigProvider.platform.android.scrolling.jsScrolling(true);

    var browserOptions = {
      location: "yes",
      toolbar: "yes"
    }

    $cordovaInAppBrowserProvider.setDefaultOptions(browserOptions);
    // Ionic uses AngularUI Router which uses the concept of states
    // Learn more here: https://github.com/angular-ui/ui-router
    // Set up the various states which the app can be in.
    // Each state's controller can be found in controllers.js
    $stateProvider.state('tab', {
      url: '/tab',
      abstract: true,
      templateUrl: 'templates/tabs.html'
    })
      .state('tab.public', {
        url: '/public',
        views: {
          'tab-public': {
            templateUrl: 'app/pages/public/tab-public.html',
            controller: 'PublicCtrl'
          }
        }
      })
      .state('tab.products', {
        url: '/products',
        views: {
          'tab-products': {
            templateUrl: 'app/pages/products/tab-products.html',
            controller: 'ProductsCtrl'
          }
        }
      })
      .state('tab.home', {
        url: '/home',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/home/tab-home.html',
            controller: 'HomeCtrl'
          }
        }
      })
      .state('tab.market', {
        url: '/market',
        views: {
          'tab-market': {
            templateUrl: 'app/pages/market/tab-market.html',
            controller: 'MarketsCtrl'
          }
        }
      })
      .state('tab.regulatory', {
        url: '/regulatory',
        views: {
          'tab-regulatory': {
            templateUrl: 'app/pages/regulatory/tab-regulatory.html',
            controller: 'RegularCtrl'
          }
        }
      })
      .state('tab.stockProList', {
        url: '/stockProList/:method/:category/:board/:title/:extra/:categoryMId/:channelPath/:keyword',
        cache: false,
        views: {
          'tab-products': {
            templateUrl: 'app/pages/products/stockProList.html',
            controller: 'ProductsCtrl'
          }
        }
      })
      .state('stockDetail', {
        url: '/stockDetail/:code/:methodList/:methodDetail/:categoryMId',
        templateUrl: 'app/pages/products/stockDetail.html',
        controller: 'ProductsCtrl'
      })
      .state('tab.stockList', {
        url: '/stockList/:method/:category/:board/:title/:categoryMId/:boardCode/:categorySId',
        views: {
          'tab-public': {
            templateUrl: 'app/pages/public/stockList.html',
            controller: 'PublicCtrl'
          }
        }
      })
      .state('tab.marketIndexList', {
        url: '/marketIndexList/:method/:category/:board/:title/:categoryMid',
        views: {
          'tab-market': {
            templateUrl: 'app/pages/market/marketIndexList.html',
            controller: 'MarketsCtrl'
          }
        }
      })
      .state('marketIndexDetail', {
        cache: false,
        url: '/marketIndexDetail/:code/:methodDetail/:categoryMid',

        templateUrl: 'app/pages/market/marketIndexDetail.html',
        controller: 'MarketsCtrl'
      })
      .state('tab.regularList', {
        url: '/regularList/:method/:category/:board/:title/:categoryMId',
        views: {
          'tab-regulatory': {
            templateUrl: 'app/pages/regulatory/regularList.html',
            controller: 'RegularCtrl'
          }
        }
      })
      .state('regularDetail', {
        cache: false,
        url: '/regularDetail/:code/:methodDetail/:categoryMId',

        templateUrl: 'app/pages/regulatory/regularDetail.html',
        controller: 'RegularCtrl'
      })
      .state('tab.login', {
        url: '/login',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/me/tab-login.html',
            controller: 'MeCtrl'
          }
        }
      })
      .state('tab.register', {
        url: '/register',
        cache:'false',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/me/tab-register.html',
            controller: 'MeCtrl'
          }
        }
      })
      .state('tab.getPwd', {
        url: '/getPwd',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/me/getPwd.html',
            controller: 'MeCtrl'
          }
        }
      })
      .state('tab.notice-detail', {
        url: '/notice-detail',
        views: {
          'tab-home': {
            templateUrl: 'templates/notice-detail.html',
            controller: 'HomeCtrl'
          }
        }
      })
      .state('tab.me', {
        url: '/me',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/me/tab-me.html',
            controller: 'MeCtrl'
          }
        }
      })
      .state('tab.myFavorite', {
        url: '/myFavorite/:product',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/me/myFavorite.html',
            controller: 'MeCtrl'
          }
        }
      })
      .state('tab.news', {
        url: '/news',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/me/news.html',
            controller: 'MeCtrl'
          }
        }
      })
      .state('tab.myMessage', {
        url: '/myMessage',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/me/myMessage.html',
            controller: 'MeCtrl'
          }
        }
      })
      .state('tab.searchResult', {
        url: '/searchResult/:searchName',
        views: {
          'tab-home': {
            templateUrl: 'app/pages/search/searchResult.html',
            controller: 'SearchCtrl'
            //controller: 'ProductsCtrl'
          }
        }
      });

    $urlRouterProvider.otherwise('/tab/home');
  });


var DOMCleaner = function (content) {
  this.dom = document.createElement('div');
  this.dom.innerHTML = content.replace(/[\u3000]/g, ' ');
}

DOMCleaner.prototype.clean = function () {
  this.cleanNode(this.dom);
  return this.dom.innerHTML;
}

DOMCleaner.prototype.cleanNode = function (dom) {
  var that = this;
  var nodeName = dom.nodeName.toLowerCase();

  // console.dir(dom);
  if ('br' === nodeName) {
    return dom;
  }

  if (['script', '#comment'].indexOf(nodeName) > -1) {
    dom.parentNode && dom.parentNode.removeChild(dom);
    return null;
  }

  if (dom.hidden || (dom.style && dom.style.display === 'none')) {
    dom.parentNode && dom.parentNode.removeChild(dom);
  }

  var nextChild = dom.firstChild
  while (nextChild) {
    var elem = nextChild;
    nextChild = nextChild.nextSibling;
    that.cleanNode(elem);
  }

  if (!dom.firstChild) {
    dom.textContent = dom.textContent.trim();
    if (!dom.textContent && dom.parentNode) {
      dom.parentNode.removeChild(dom);
      return null;
    }
  }
  if (nodeName != '#text') {
    dom.removeAttribute('style');
    dom.removeAttribute('align');
    dom.removeAttribute('class');
    dom.removeAttribute('width');
    dom.removeAttribute('border');
  }

  if ('a' == nodeName) {
    var span = document.createElement("span");
    span.innerHTML = dom.innerHTML;
    dom.parentNode.insertBefore(span, dom);
    dom.parentNode.removeChild(dom);
  }
  // if (nodeName == "#text") {
  //   var p = document.createElement("p");
  //   p.textContent = dom.textContent;
  //   dom.parentNode.insertBefore(p, dom);
  //   dom.parentNode.removeChild(dom);
  // }
  return dom;
}

window.DOMCleaner = DOMCleaner;
window.BaseReg = {
  phone: /^(?=\d{11}$)^1(?:3\d|4[57]|5[^4\D]|7[^249\D]|8\d)\d{8}$/,
  valiCode: /^\d{6}$/,
  username: /^\S{6,20}$/,
  password: /^\S{6,20}$/
};

/**
 * 计算字符串字节
 * @param  {string} charset 编码
 * @return {integer}        字节数大小
 */
window.String.prototype.getByteSize = function (charset) {
  var str = this,
    total = 0,
    charCode,
    i,
    len;
  charset = charset ? charset.toLowerCase() : '';
  if (charset === 'utf-16' || charset === 'utf16') {
    for (i = 0, len = str.length; i < len; i++) {
      charCode = str.charCodeAt(i);
      if (charCode <= 0xffff) {
        total += 2;
      } else {
        total += 4;
      }
    }
  } else {
    for (i = 0, len = str.length; i < len; i++) {
      charCode = str.charCodeAt(i);
      if (charCode <= 0x007f) {
        total += 1;
      } else if (charCode <= 0x07ff) {
        total += 2;
      } else if (charCode <= 0xffff) {
        total += 3;
      } else {
        total += 4;
      }
    }
  }
  return total;
}
